{ ****** PARAMETRE ****** }

Type TpParam = Record
         n : string[4];
         m : byte;   { 0=> rien 1=> Flip/Flop +-  2=paramtre }
       End;

Const P_Rien = 0;
      P_Flip = 1;
      P_Egal = 2;

      CFGFileName : string[12] = 'NAMSIM.CFG';

      NbParam = 35;
      TabParam : array[1..NbParam] of TpParam = (
        ( n:'MDA';  m:P_Rien ),  { ecran mono }
        ( n:'CGA';  m:P_Rien ),  { ecran CGA 25 lignes }
        ( n:'COM';  m:P_Egal ),  { COM=adresse,irq }
        ( n:'COM1'; m:P_Rien ),  { COM1 (quivalent de COM=$3F8,4) }
        ( n:'COM2'; m:P_Rien ),  { COM2 }
        ( n:'COM3'; m:P_Rien ),  { COM3 }
        ( n:'COM4'; m:P_Rien ),  { COM4 }
        ( n:'BUF';  m:P_Egal ),  { BUF=in,out }
        ( n:'PAR';  m:P_Egal ),  { PAR=0..3 }
        ( n:'SPD';  m:P_Egal ),  { SPD=0..5 (12,24,48,96,19200 }
        ( n:'?';    m:P_Rien ),  { ? affiche une aide }
        ( n:'CALL'; m:P_Egal ),  { CALL=0..9A..F,donne }
        ( n:'CSTR'; m:P_Egal ),  { CSTR=1..10,donne }
        ( n:'EGA';  m:P_Rien ),  { ecran EGA }
        ( n:'VGA';  m:P_Rien ),  { ecran VGA }
        ( n:'EGA2'; m:P_Rien ),  { ecran EGA sombre }
        ( n:'GRIS'; m:P_Flip ),  { vga gris }
        ( n:'SNOW'; m:P_Flip ),  { cga avec neige ? }
        ( n:'CL';   m:P_Flip ),  { Champ CL ? }
        ( n:'FREE'; m:P_Flip ),  { saisie libre }
        ( n:'CNX';  m:P_Flip ),  { connexion immdiate }
        ( n:'NAM';  m:P_Rien ),  { NAM }
        ( n:'MIN';  m:P_Rien ),  { MIN }
        ( n:'RTC';  m:P_Flip ),  { RTC }
        ( n:'NAB';  m:P_Egal ),  { NAB=NAB,CSTR }
        ( n:'DRCS'; m:P_Flip ),  { DRCS }
        ( n:'TCNX'; m:P_Egal ),  { TCNX=1..20 (secondes) }
        ( n:'TOUT'; m:P_Flip ),  { TOUT timeout ou non ? }
        ( n:'RESO'; m:P_Flip ),  { RESO }
        ( n:'#NAM'; m:P_Egal ),  { #NAM=nnam associ au minitel }
        ( n:'PAV';  m:P_Egal ),  { PAV=nombre a prevoir ... reli a un PAV ??? }
        ( n:'R2F';  m:P_Rien ),  { R2F le renvoi des trames 0x2F inconnu }
        ( n:'ETB';  m:P_Flip ),  { ETB }
        ( n:'HISPD'; m:P_Rien ), { HISPD... autorise les vitesses >38400 }
        ( n:'SUBST'; m:P_Egal )  { SUBST=C:\,F:\NAMSIM\ }
        );

      _MDA  = 1;
      _CGA  = 2;
      _COM  = 3;
      _COM1 = 4;
      _COM2 = 5;
      _COM3 = 6;
      _COM4 = 7;
      _BUF  = 8;
      _PAR  = 9;
      _SPD  = 10;
      _HELP = 11;
      _CALL = 12;
      _CSTR = 13;
      _EGA  = 14;
      _VGA  = 15;
      _EGA2 = 16;
      _GRIS = 17;
      _SNOW = 18;
      _CL   = 19;
      _FREE = 20;
      _CNX  = 21;
      _NAM  = 22;
      _MIN  = 23;
      _RTC  = 24;
      _NAB  = 25;
      _DRCS = 26;
      _TCNX = 27;
      _TOUT = 28;
      _RESO = 29;
      _DNAM = 30;
      _PAV  = 31;
      _R2F  = 32;
      _ETB  = 33;
      _HISPD= 34;
      _SUBST= 35;


function _FileSeek( Var Name : String ) : String;
var s : string;
    r : DirStr;
    n : NameStr;
    e : ExtStr;
    f : File;
begin
  { recherche d'abord dans le rpertoire courant }
  Assign(f,Name);
  reset(f,1);
  if IoResult=0 then
   Begin
    Close(f);
    _FileSeek := Name;
    exit;
   End;

  { recherche dans le rpertoire o est l'executable }
  s := ParamStr(0);
  if s<>'' then
    begin
      FSplit(s,r,n,e);
      s := r+Name;
      Assign(f,s);
      reset(f,1);
      if IoResult=0 then
       Begin
        Close(f);
        _FileSeek := s;
        exit;
       End;
    end;

(*
  { recherche dans le PATH dos }
  s := FSearch(Name,GetEnv('PATH'));
  if s<>'' then
    begin
      Assign(f,s);
      reset(f,1);
      if IoResult=0 then
       Begin
        Close(f);
        _FileSeek := s;
        exit;
       End;
    end;
*)

  _FileSeek := '';
end;

function FileSeek( Name : String ) : String;
Begin
 FileSeek := _FileSeek(Name);
End;

function FileParam( var f : text ) : boolean;
Var s : String;
begin
  s := _FileSeek(CFGFileName);
  If s<>'' Then
   Begin
    Assign(f,s);
    reset(f);
    if IoResult=0 then FileParam := TRUE
    Else FileParam := FALSE;
   End
  Else FileParam := FALSE;
end;


Function ValBin( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
    cld
    push ds
    lds  si, [S]
    lodsb               { lire la longueur de la chaine }
    xor  ah, ah         { longueur de la chaine dans AX }

    mov  cx, ax
    jcxz @FALSE         { saute si chaine vide }
    xor  bx, bx
    xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
    lodsb               { lit le car }
    sub  al, '0'        { -'0' }
    cmp  al, 1
    ja   @FALSE         { erreur de syntaxe! '0' ou '1' seulement ! }
    cmc                 { car, si al=1 => cf=0, si al<1 => cf=1 !! }
    rcl  bx, 1          { rotate with carry }
    rcl  dx, 1
    jc   @FALSE         { depassement de capacit 16 bits ! }
    loop @BOUCLE

    lds  si, [x]
    mov  [si], bx
    mov  [si+2], dx     { ecrit le resultat }
    mov  al, TRUE       { sort avec TRUE }
    JMP  @FIN
@FALSE:
    XOR  AL, AL
@FIN:
    pop  ds
End;


Function ValHex( Var S : String; Var x : Longint ) : Boolean; Assembler;
Asm
        cld
        push ds
        lds  si, [S]
        lodsb
        xor  ah, ah         { longueur de la chaine dans AX }
        mov  cx, ax
        jcxz @FALSE         { saute si vide }
        xor  bx, bx
        xor  dx, dx         { dx:bx = entier long en cours d'etude }
@BOUCLE:
        lodsb               { lit le car }
        cmp  al, 'a'
        jb   @03
        cmp  al, 'f'
        ja   @FALSE         { car incorrecte }
        sub  al, 32         { -32!  UpCase(al) }
        jmp  @05
@03:
        cmp  al, '0'
        jb   @FALSE
        cmp  al, '9'
        ja   @04
        {
          0..9
        }
        sub  al, '0'
        jmp  @CONT
@04:
        cmp  al, 'A'
        jb   @FALSE
        cmp  al, 'F'
        ja   @FALSE
        {
          A..F
        }
@05:
        sub  al, 'A'-10
@CONT:
        test dx, 0F000h
        jnz  @FALSE         { depassement de capacit }
        push cx             { sauve cx }
        mov  cl, 4
        shl  dx, cl         { dx*16  dx= xxxx xxxx xxxx 0000 }
        mov  ah, bh         {        ah= ???? xxxx           }
        shr  ah, cl         {        ah= 0000 ????           }
        or   dl, ah         {        dx= xxxx xxxx xxxx ???? }
        shl  bx, cl
        or   bl, al
        pop  cx             { restore cx }
        loop @BOUCLE

        lds  si, [x]
        mov  [si], bx
        mov  [si+2], dx     { ecrit le resultat }
        mov  al, TRUE       { sort avec TRUE }
        JMP  @FIN
@FALSE:
        xor  al, al
@FIN:
        pop  ds
End;


{ traduction en fonction du type de nombre }

Function ValX( Var S : String; Var x : Longint ) : Boolean;
Var SN  : String[32];
    Err : Word;
Begin
  If (S<>'') And (Length(S)<SizeOf(SN)) Then
    Case UpCase(S[1]) Of
      '%','B' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValBin(SN,x);
                End;
      '$','H' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  ValX := ValHex(SN,x);
                End;
      '#','D' : Begin
                  SN[0] := Char(Length(S)-1);
                  Move(S[2],SN[1],Length(SN));
                  Val(SN,x,Err);
                  ValX := Err=0;
                End;
    Else
      Case UpCase(S[Length(S)]) Of
        'B' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValBin(SN,x);
              End;
        'H' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                ValX := ValHex(SN,x);
              End;
        'D' : Begin
                SN[0] := Char(Length(S)-1);
                Move(S[1],SN[1],Length(SN));
                Val(SN,x,Err);
                ValX := Err=0;
              End;
      Else
        Begin
          Val(S,x,Err);
          ValX := Err=0;
        End;
      End
    End
  Else ValX := FALSE;
End;


Function StrStr( var s : String; nPar : Word;
                 var result : String; SizeMax : Byte ) : boolean;
var i : word;
    n : String;
begin
  i := 1;
  while nPar>1 do
    begin
      while (i<=length(s)) and (s[i]<>',') do inc(i);
      if i>length(s) then
        begin
          result := '';
          StrStr := TRUE;
          exit;
        end;
      dec(nPar);
      inc(i);
    end;
  n := '';
  while (i<=length(s)) and (s[i]<>',') do
    begin
      inc(n[0]);
      n[length(n)] := s[i];
      inc(i);
    end;
  If SizeMax<Length(n) Then n[0] := Char(SizeMax);

  Result := n;
  StrStr := TRUE;
end;



Function StrVal( var s : String; nPar : Word;
                 var result : Word; default : Word ) : Boolean;
Var n : String[20];
    x : Longint;
Begin
 If StrStr(s,nPar,n,SizeOf(n)-1) Then
  If n='' Then
   Begin
    result := default;
    StrVal := TRUE;
   End
  Else
   Begin
    If ValX(n,x) And (x>=0) And (x<=65535) then
     Begin
      result := Word(x);
      StrVal := TRUE;
     End
    Else StrVal := FALSE;
   End
 Else StrVal := FALSE;
End;


Function StrValLong( var s : String; nPar : Word;
                     var result : LongInt; default : LongInt ) : Boolean;
Var n : String[20];
    x : Longint;
Begin
 If StrStr(s,nPar,n,SizeOf(n)-1) Then
  If n='' Then
   Begin
    result := default;
    StrValLong := TRUE;
   End
  Else
   Begin
    If ValX(n,x) And (x>=0) And (x<=115200) then
     Begin
      result := x;
      StrValLong := TRUE;
     End
    Else StrValLong := FALSE;
   End
 Else StrValLong := FALSE;
End;


Procedure ConfigErreur( txt : string; nLig, nParam : Word );
Begin
 If nLig>0 Then Writeln(txt,'  ligne n',nLig,'  param.n',nParam)
 Else Writeln(txt,'   param.n',nParam);
End;


Function  TradComParam( s : String; Var Param : Byte ) : Boolean;
Var a : Word;
Begin
 TradComParam := FALSE;
 If Length(s)=3 Then
  Begin
   Case UpCase(s[1]) Of
    'E' : a := EVENPARITY;
    'O' : a := ODDPARITY;
    'N' : a := NOPARITY;
   Else Exit;
   End;

   Case s[2] Of
    '5' : Inc(a,DATA5BITS);
    '6' : Inc(a,DATA6BITS);
    '7' : Inc(a,DATA7BITS);
    '8' : Inc(a,DATA8BITS);
   Else Exit;
   End;

   Case s[3] Of
    '1' : Inc(a,STOP1BIT);
    '2' : Inc(a,STOP2BITS);
   Else Exit;
   End;

   Param := a;
   TradComParam := TRUE;
  End;
End;


Procedure ClasseNam;
Begin
 If (CNam<>NIL) Then
  If (CNam^.Cfg.UART=0) Then
   Begin
    Dispose(CNam);
    TNam[nCNam] := NIL;
   End
  Else TNam[nCNam] := CNam;
 CNam := NIL;
End;

Procedure ClasseMin;
Begin
 If (CMin<>NIL) Then
  If (CMin^.Cfg.UART=0) Then
   Begin
    Dispose(CMin);
    TMin[nCMin] := NIL;
   End
  Else TMin[nCMin] := CMin;
 CMin := NIL;
End;

Procedure ClassePav;
Begin
 If (CPav<>NIL) Then
  If (CPav^.Cfg.UART=0) Then
   Begin
    Dispose(CPav);
    TPav[nCPav] := NIL;
   End
  Else TPav[nCPav] := CPav;
 CPav := NIL;
End;

Function  TraiteOption( p : TpParam; Plus : boolean; var sp : string
                      ) : String;
Var i  : word;
    t  : Word;
    l  : LongInt;
    Ok : Boolean;
    z  : Byte;
    s  : ^String;
Begin
{  writeln(nLig:4,' ',n:4,' "',p.n,'" ',p.m,' ',Plus,' "',sp,'"'); }
 For i := 1 To Length(p.n) Do p.n[i] := UpCase(p.n[i]);
 For i := 1 To NbParam Do
  If TabParam[i].n=p.n Then
   Begin
    If (TabParam[i].m<>p.m) And
       Not((p.m=P_Rien) And (TabParam[i].m=P_Flip)) Then
      Begin
       TraiteOption := 'Option mal utilise';
       Exit;
      End;

    Ok := TRUE;

    Case i Of
      _MDA  : VideoMode := VMODE_MDA;
      _CGA  : VideoMode := VMODE_CGA;
      _HELP : NeedHelp := TRUE;
      _CSTR : If StrStr(sp,1,TabCStr[FCStr],SizeOf(CallStr)-1) Then
               Begin
                Inc(FCStr);
                If FCStr>=NbCStr Then FCStr := 0;
               End
              Else Ok := FALSE;
      _NAB  : If (NbNab<NABMax) And
                 StrStr(sp,1,TabNAB[NbNab].NAB,SizeOf(TabNAB[NbNab].NAB)-1) And
                 StrStr(sp,2,TabNAB[NbNab].CStr,SizeOf(CallStr)-1) Then
               Begin
                s := @TabNAB[NbNab].NAB;
                For z := 1 To Length(s^) Do s^[z] := UpCase(s^[z]);
                Inc(NbNab);
               End
              Else Ok := FALSE;
      _SUBST : If StrStr(sp,1,SUBST_Old,SizeOf(SUBST_Old)) And
                  StrStr(sp,2,SUBST_New,SizeOf(SUBST_New)) Then
                Begin
                End
               Else Ok := FALSE;
      _EGA  :
       Begin
        VideoMode := VMODE_EGA;
        EGALight := FALSE;
       End;
      _EGA2 :
       Begin
        VideoMode := VMODE_EGA;
        EGALight := TRUE;
       End;
      _VGA  :
       Begin
        VideoMode := VMODE_VGA;
       End;
      _GRIS : Grey := Plus;
      _SNOW : Neige := Plus;
      _RESO : EnReso := Plus;
      _ETB  : UseETB := Plus;
      _NAM  : Begin
               If nCNam>=NamMax Then
                Begin
                 Ok := FALSE;
                End
               Else
                Begin
                 ClasseNam;
                 ClasseMin;
                 ClassePav;

                 Inc(nCNam);
                 New(CNam);

                 FillChar(CNam^,SizeOf(CNam^),0);

                 With CNam^ Do
                  Begin
                   nNam := nCNam;
                   Com.CL_Exist  := TRUE;
                   Com.LG_ENTETE := 4;
                   Cfg := NamComDefault;
                   NCfg := NamCfgDefault;
                   nVoie := 0;
                   GlDispo := TRUE;
                   Passe := '';
                  End;

                 For z := 0 To MaxNbVoies-1 Do
                  With CNam^.TabVoies[z] Do
                   Begin
                    LastCnxC18 := 0;
                    CStr    := '';
                    SaveCStr := '';
                    ComOn   := FALSE;
                    Dispo   := FALSE;
                    LastIn  := 0;
                    LastOut := 0;
                    Roto    := 0;
                    Input   := '';
                    (*
                    MinCnx  := FALSE;
                    *)
                    (*
                    Min     := NIL;
                    Auto    := FALSE;
                    Start   := FALSE;
                    *)
                   End;

                 CCfg := @CNam^.Cfg;
                End;
              End;
      _MIN : Begin
              If nCMin>=MinMax Then
               Begin
                Ok := FALSE;
               End
              Else
               Begin
                ClasseNam;
                ClasseMin;
                ClassePav;

                Inc(nCMin);
                New(CMin);

                FillChar(CMin^,SizeOf(CMin^),0);

                With CMin^ Do
                 Begin
                  Cfg := MinComDefault;
                  Eq := DefaultLocalMatCfg;
                  Pavi.Seq.NoTimeOut := TRUE;
                  Sys.Page := DefaultPage;
                  Sys.TCnx := Default_TCNX*18;
                 End;

                CCfg := @CMin^.Cfg;
               End;
             End;
      _PAV : If StrVal(sp,1,t,PavMinMax) And (t>0) And (t<=PavMinMax) Then
              Begin
               If nCPav>=PavMax Then
                Begin
                 Ok := FALSE;
                End
               Else
                Begin
                 ClasseNam;
                 ClasseMin;
                 ClassePav;

                 Inc(nCPav);
                 New(CPav);

                 FillChar(CPav^,SizeOf(CPav^),0);

                 With CPav^ Do
                  Begin
                   nPav := nCPav;
                   Com.CL_Exist  := FALSE;      { c'est ainsi vers le PAV! }
                   Com.LG_ENTETE := 2;
                   Cfg := PavComDefault;
                   PCfg := PavCfgDefault;
                   PCfg.MinMax := t;
                  End;

                 For z := 1 To PavMinMax Do CPav^.TMin[z] := Nil;

                 For z := 1 To t Do
                  Begin
                   New(CPav^.TMin[z]);
                   FillChar(CPav^.TMin[z]^,SizeOf(CPav^.TMin[z]^),0);
                   With CPav^.TMin[z]^ Do
                    Begin
(*                     Sys.NoTimeOut := TRUE; *)
                     Sys.Page := DefaultPage;
                     Sys.TCnx := Default_TCNX*18;
                    End;
                  End;

                 CCfg := @CPav^.Cfg;
                End;
              End;
    Else
     If CCfg<>NIL Then
      Begin
       Case i Of
        _COM  : If StrVal(sp,2,t,CCfg^.IRQ) Then
                 If t=$FF Then { gestion DIGI }
                  If StrVal(sp,1,CCfg^.UART,0) Then
                    Begin
                     CCfg^.IRQ := Byte(t);
                     TraiteOption := '';
                    End
                  Else Ok := FALSE
                 Else
                  If (t<16) And StrVal(sp,1,CCfg^.UART,0) And
                     (CCfg^.UART And 7=0) Then
                    Begin
                     CCfg^.IRQ := Byte(t);
                     TraiteOption := '';
                    End
                  Else Ok := FALSE
                Else Ok := FALSE;
        _COM1 : Begin
                 CCfg^.UART := Memw[$0040:$0000];
                 CCfg^.IRQ  := 4;
                End;
        _COM2 : Begin
                 CCfg^.UART := Memw[$0040:$0002];
                 CCfg^.IRQ  := 3;
                End;
        _COM3 : Begin
                 CCfg^.UART := Memw[$0040:$0004];
                 CCfg^.IRQ  := 4;
                End;
        _COM4 : Begin
                 CCfg^.UART := Memw[$0040:$0006];
                 CCfg^.IRQ  := 3;
                End;

        _BUF  : Ok := StrVal(sp,1,CCfg^.BufIn,CCfg^.BufIn) And
                      StrVal(sp,2,CCfg^.BufOut,CCfg^.BufOut) And
                      (CCfg^.BufIn>=256) And (CCfg^.BufOut>=256);
        _PAR : Begin
                If sp='' Then CCfg^.Par := DATA8BITS+NOPARITY+STOP1BIT
                Else Ok := TradComParam(sp,CCfg^.Par);
               End;
        _SPD  : If StrValLong(sp,1,l,CCfg^.Spd) Then
                 Begin
                  CCfg^.Spd := l;
                  If (l>38400) And (CNam<>NIL) Then CNam^.NCfg.HiSpd := TRUE;
                 End
                Else Ok := FALSE;
       Else
        Begin
         If CNam<>NIL Then
          Begin
           Case i Of
            _CALL : Ok := StrVal(sp,1,t,0) And (t<NbVoies) And
                          StrStr(sp,2,CNam^.TabVoies[t].CStr,SizeOf(CallStr)-1);
            _CL   : Begin
                     If Plus Then
                      Begin
                       CNam^.Com.CL_Exist  := TRUE;
                       CNam^.Com.LG_ENTETE := 4;
                      End
                     Else
                      Begin
                       CNam^.Com.CL_Exist  := FALSE;
                       CNam^.Com.LG_ENTETE := 2;
                      End;
                    End;
            _FREE : CNam^.NCfg.SaisieLibre := PLUS;
            _CNX  : CNam^.NCfg.CnxAuto := PLUS;
            _DRCS : CNam^.NCfg.UseDRCS := PLUS;
            _HISPD: CNam^.NCfg.HiSpd := TRUE;
           Else Ok := FALSE;
           End;
          End
         Else
          If CMin<>NIL Then
           Begin
            Case i Of
             _RTC : If Plus Then
                     Begin
                      CMin^.Eq := DefaultRTCMatCfg;
                      CMin^.Pavi.Seq.NoTimeOut := FALSE;
                     End
                    Else
                     Begin
                      CMin^.Eq := DefaultLocalMatCfg;
                      CMin^.Pavi.Seq.NoTimeOut := TRUE;
                     End;
             _TCNX : If StrVal(sp,1,t,Default_TCNX) And (t>0) And (t<=20) Then
                      CMin^.Sys.TCnx := t*18
                     Else Ok := FALSE;
             _TOUT : CMin^.Pavi.Seq.NoTimeOut := Not(Plus);
             _DNAM : If StrVal(sp,1,t,1) And (t>0) And (t<=NamMax) Then CMin^.MainNam := t
                     Else Ok := FALSE;
            Else Ok := FALSE;
            End;
           End
          Else
           If CPav<>NIL Then
            Begin
             Case i Of
              _R2F : R2F_nPAV := nCPav;
             Else Ok := FALSE;
             End;
            End
           Else Ok := FALSE;

        End;
       End;
      End
     Else Ok := FALSE;
    End;

    If Ok Then TraiteOption := ''
    Else TraiteOption := 'Paramtre incorrect';

    Exit;
   End;
 TraiteOption := 'Option inconnue';
End;



Function AnalyseOption( Var p : TpParam; Var Plus : Boolean; Var v : String ) : Boolean;
Var x : Word;
Begin
 If (v<>'') And ((v[1]='/') Or (v[1]='-')) Then
  Begin
   If v[Length(v)]='+' then
    Begin
     p.n  := Copy(v,2,length(v)-2);
     p.m  := P_Flip;
     v    := '';
     Plus := TRUE;
    End
   Else
    If v[Length(v)]='-' then
     Begin
      p.n  := Copy(v,2,length(v)-2);
      p.m  := P_Flip;
      v    := '';
      Plus := FALSE;
     End
    Else
     Begin
      x := Pos('=',v);
      If x=0 Then
       Begin
        p.n  := Copy(v,2,length(v)-1);
        p.m  := P_Rien;
        v    := '';
        Plus := TRUE;
       End
      Else
       Begin
        p.n  := Copy(v,2,x-2);
        p.m  := P_Egal;
        v    := Copy(v,x+1,255);
        Plus := FALSE;
       End;
     End;
   AnalyseOption := TRUE;
  End
 Else AnalyseOption := FALSE;
End;


Function TraiteParam( s : String; nLig, nParam : Word ) : Boolean;
Var p      : TpParam;
    Plus   : Boolean;
Begin
 If AnalyseOption(p,Plus,s) Then
  Begin
   s := TraiteOption(p,Plus,s);
   If s<>'' Then
    Begin
     ConfigErreur(s,nLig,nParam);
     TraiteParam := FALSE;
     Exit;
    End;
  End
 Else
  Begin
   ConfigErreur('Erreur de syntaxe',nLig,nParam);
   TraiteParam := FALSE;
   Exit;
  End;
 TraiteParam := TRUE;
End;


Function ChargeParamLigne : Boolean;
Var nParam : Byte;
Begin
 For nParam := 1 To ParamCount Do
  Begin
   If Not(TraiteParam(ParamStr(nParam),0,nParam)) Then
    Begin
     ChargeParamLigne := FALSE;
     Exit;
    End;
  End;
 ChargeParamLigne := TRUE;
End;


Function TraiteLigne( Var Lig : String; nLig : Word ) : Boolean;
Var s      : String;
    i      : Byte;
    nParam : Word;
Begin
 nParam := 0;
 i := 1;
 While i<=Length(Lig) Do
  Begin
   If Lig[i]<>' ' Then
    Begin
     s := '';
     Repeat
      Inc(s[0]);
      s[Length(s)] := Lig[i];
      Inc(i);
     Until (i>Length(Lig)) Or (Lig[i]=' ');

     Inc(nParam);

     If Not(TraiteParam( s, nLig, nParam )) Then
      Begin
       TraiteLigne := FALSE;
       Exit;
      End;
    End
   Else Inc(i);
  End;
 TraiteLigne := TRUE;
End;


Function ChargeParamFile( Var f : Text ) : Boolean;
Var nLig : Word;
    Lig  : String;
Begin
 nLig := 0;
 While Not(Eof(f)) Do
  Begin
   Inc(nLig);
   Readln(f,Lig);
   If Lig<>'' Then
    Begin
     If Not(TraiteLigne(Lig,nLig)) Then
      Begin
       ChargeParamFile := FALSE;
       Exit;
      End;
    End
  End;
 ChargeParamFile := TRUE;
End;


Function ChargeParam : Boolean;
Var f : Text;
Begin
 If FileParam(f) Then
  Begin

   If Not(ChargeParamFile(f)) Then
    Begin
     ChargeParam := FALSE;
     Close(f);
     Exit;
    End;

   Close(f);
  End;

 ChargeParam := ChargeParamLigne;
End;



