(********************************
 *                              *
 *          MINCTRL             *
 *                              *
 ********************************)

Procedure MinInit;
Var i : Byte;
Begin
 For i := 1 To MinMax Do
  Begin
   If TMin[i]<>NIL Then
    Begin
     With TMin[i]^ Do
      Begin
       Buf.iWrite := 0;
       Buf.Nb := 0;
       MPos := MPOS_RESET;

       Com.Send(Eq.IReset[1],length(Eq.IReset));

       SysInit(Sys);
      End;
    End;
  End;
End;


Procedure AbortConnect( Var c : MinDef );
Const ComOff : String[35] = #$00#$00#$14#$14+POSLZ+'fin de communication'#$0A#$00#$00#$00;
Begin
 c.Com.TransmitClear;
 c.Com.ReceiveClear;
 c.Com.Send(ComOff[1],Length(ComOff));
 c.Com.Send(c.Eq.SHangUp[1],Length(c.Eq.SHangUp));
 c.Com.Send(c.Eq.IReset[1],Length(c.Eq.IReset));
 c.MPos := MPOS_RESET;                                  { fin de com... }
End;


Procedure MinDone;
Var i : Byte;
    Wait : Boolean;
    t : Longint;
    m : PMinDef;
    How : Word;
Begin
 For i := 1 To MinMax Do
  Begin
   If TMin[i]<>NIL Then
    Begin
     m := TMin[i];

     If m^.MPos<>MPOS_WRING Then
      Begin
       SysDeco(m^.Sys,0,0);
       AbortConnect(m^);
      End
     Else m^.Com.Send(m^.Eq.IReset[1],Length(m^.Eq.IReset));
    End;
  End;

 t := GetC18+5*18;
 Repeat
  Wait := FALSE;
  For i := 1 To MinMax Do
   If (TMin[i]<>NIL) And (TMin[i]^.Com.TransmitCount>0) Then
    Begin
     Wait := TRUE;
     Break;
    End;
 Until Not(Wait) Or (t<=GetC18);

End;




{ -------------------- }

Function  GetComChar( Var c : MinDef; Var r : Char ) : Boolean;
Var z : Char;
Begin
 If c.Com.ReceiveChar(z) Then
  Begin
   c.Buf.Buf[c.Buf.iWrite] := z;
   Inc(c.Buf.iWrite);
   If c.Buf.iWrite>=ComBufSize Then c.Buf.iWrite := 0;
   If c.Buf.Nb<ComBufSize Then Inc(c.Buf.Nb);
   r := z;
   GetComChar := TRUE;
  End
 Else GetComChar := FALSE;
End;


Function  DetectComBuf( Var c : MinDef; s : String ) : Boolean;
Var Nb  : Byte;
    i   : Byte;
    iRead : Byte;
Begin
 If s='' Then DetectComBuf := FALSE
 Else
  Begin
   Nb    := c.Buf.Nb;
   i     := Length(s);

   If (Nb>=i) Then
    Begin

     iRead := c.Buf.iWrite;
     If iRead=0 Then iRead := ComBufSize-1 Else Dec(iRead);

     While (i>0) And ((s[i]=#0) Or (s[i]=#1) Or
            (s[i]=c.Buf.Buf[iRead]))  Do
      Begin
       If iRead=0 Then iRead := ComBufSize-1 Else Dec(iRead);
       Dec(i);
      End;
    End;

   DetectComBuf := i=0;
  End;
End;


Function  GetDetectComBuf( Var c : MinDef; s : String ) : Boolean;
Var z : Char;
Begin
 If GetComChar(c,z) Then GetDetectComBuf := DetectComBuf(c,s)
 Else GetDetectComBuf := FALSE;
End;


Procedure Min_WRing( Var c : MinDef );
Var z   : Char;
Begin
 If GetComChar(c,z) Then
  Begin
   If DetectComBuf(c,c.Eq.WCall) Then
    Begin { Trouv ! }
          { on active CV ... }
     c.Com.Send(c.Eq.SConnect[1],Length(c.Eq.SConnect));

     c.MPos := MPOS_WCNX;
     c.TimeOut := GetC18+c.Eq.TConnect;
    End;
  End;
End;


Procedure Min_Reset( Var c : MinDef );
Begin
 If c.Com.TransmitCount=0 Then c.MPos := MPOS_WRING;
End;

Procedure ConnectOk( Var c : MinDef );
Const ComOn : String[24] = #$0C'communication '#$19#$42'etablie';
Begin
 FillChar(c.Pavi,SizeOf(c.Pavi),0);

 c.Pavi.DataSize := 128;
 c.Pavi.TC       := TC_VDXT;
 c.Pavi.Echo.Echo := FALSE;
 c.Pavi.Seq.Seq   := '';
 c.Pavi.Seq.Aig   := VA_NIL;
 c.Pavi.Seq.Ti    := GetC18;
 c.Pavi.Seq.Avert := FALSE;


 c.Pavi.Echo.Echo := TRUE;
 c.Pavi.Echo.Flush := FALSE;

 c.MPos := MPOS_CNX;

 { genere un appel entrant!!! }

 SysConnect(c.Sys,c.MainNam);

 { on rentre dans le domaine de la connexion avec le moooonde }

 PaqSendData(c.Sys.PaqOut,c.Eq.SConnect[1],Length(c.Eq.SConnect));
 PaqSendData(c.Sys.PaqOut,c.Eq.SOnLine[1],Length(c.Eq.SOnLine));
 PaqSendData(c.Sys.PaqOut,ComOn[1],Length(ComOn));
End;


Procedure Min_WCnx( Var c : MinDef );
Begin
 If (c.Eq.TConnect=0) Or (c.Eq.WConnect='') Then ConnectOk(c)   { connexion sans attendre }
 Else
  If GetDetectComBuf(c,c.Eq.WHangUp0) Then AbortConnect(c)
  Else
   If DetectComBuf(c,c.Eq.WConnect) Then ConnectOk(c)
   Else
    If c.TimeOut<=GetC18 Then AbortConnect(c);
End;


{ ===== Dans un etat connect !!!! ==== }


Function  ClassChar( c : Char; Aig : VDTAig; Var TpIn : ResultAig ) : VDTAig;
Begin
 Case Aig Of
  VA_NIL : Begin
            If c<#$20 Then
             Case c Of
              #$01 :
               Begin
                Aig  := VA_SOH;
                TpIn := RA_SOH;
               End;
              #$12 :
               Begin
                Aig  := VA_1;
                TpIn := RA_REP;
               End;
              #$13 :
               Begin
                Aig  := VA_1;
                TpIn := RA_SEP;
               End;
              #$19 :
               Begin
                Aig  := VA_SS2;
                TpIn := RA_SS2;
               End;
              #$1B :
               Begin
                Aig  := VA_ESC;
                TpIn := RA_ESC;
               End;
              #$1D :
               Begin
                Aig  := VA_1;
                TpIn := RA_SS3;
               End;
              #$1F :
               Begin
                Aig  := VA_2;
                TpIn := RA_US;
               End;
             Else TpIn := RA_CTRL;
             End
            Else TpIn := RA_CHAR;
           End;
   VA_1   : Aig := VA_NIL;
   VA_2   : Aig := VA_1;
   VA_3   : Aig := VA_2;
   VA_ESC : Case c Of
             #$20..#$2F :
              Begin
               Aig  := VA_ISO2022;
               TpIn := RA_ISO2022;
              End;
             #$35..#$37 :
              Begin
               Aig  := VA_1;
               TpIn := RA_FILT;
              End;
             #$39 :
              Begin
               Aig  := VA_1;
               TpIn := RA_PRO;
              End;
             #$3A :
              Begin
               Aig  := VA_2;
               TpIn := RA_PRO;
              End;
             #$3B :
              Begin
               Aig  := VA_3;
               TpIn := RA_PRO;
              End;
             #$5B :
              Begin
               Aig  := VA_ISO6429;
               TpIn := RA_ISO6429;
              End;
             #$61 :
              Begin { considere comme pro }
               Aig  := VA_NIL;
               TpIn := RA_PRO;
              End;
            Else
             Begin
              Aig  := VA_NIL;
              TpIn := RA_ESC;
             End;
            End;
   VA_ISO6429 : If c>=#$40 Then Aig := VA_NIL;
   VA_ISO2022 : If c>=#$30 Then Aig := VA_NIL;
   VA_SS2     : If (c>=#$40) And (c<=#$4F) Then Aig := VA_1
                Else Aig := VA_NIL;
   VA_SOH     : If c=#$04 Then Aig := VA_NIL;  { Fin de squence }
 Else Aig := VA_NIL;
 End;
 ClassChar := Aig;
End;


Procedure TransCodeSeq( TC : Transcodage; Var Seq : SeqStr; Var Tp : ResultAig );
Begin { Transcoder si necessaire }
 If Tp=RA_CTRL Then
  Begin
   If Seq[1]=#$1A Then
    Begin
     Seq[1] := #$7F;
     Tp     := RA_CHAR;
    End;
  End
 Else
  If (Tp=RA_SEP) And (Seq[2]>='A') And (Seq[2]<='H') Then
   If TC=TC_VDXT Then
    Begin
     Tp     := RA_ISO2022;
     Seq[0] := #2;
     Seq[1] := Seq[2];
     Seq[2] := #$0D;
    End
   Else
    If TC=TC_ISO2022 Then
     Begin
      Tp     := RA_ISO2022;
      Seq[0] := #4;
      Seq[1] := #$1B;
      Seq[3] := Char($30+((Byte(Seq[2]) Shr 4) And $0F));
      Seq[2] := Char($20+(Byte(Seq[2]) And $0F));
      Seq[4] := #$0D;

      If Seq[2]=#$2F Then Seq[2] := #$25
      Else If Seq[2]=#$25 Then Seq[2] := #$2F;
     End;
End;

Function  SeqEnvoi( Var c : MinDef ) : Boolean;
Begin
 SeqEnvoi := ((c.Pavi.Seq.Tp=RA_SEP) And (c.Pavi.Seq.Seq[2] In[#$20..#$49,#$60..#$6F])) Or
             (c.Pavi.Seq.Tp=RA_ISO2022) Or
             ((c.Pavi.Seq.Tp=RA_CTRL) And ((c.Pavi.Seq.Seq[1]=#$04) Or (c.Pavi.Seq.Seq[1]=#$0D)));
End;

Function SeqAck( Var c : MinDef ) : Boolean;
Begin
 SeqAck := (c.Pavi.Seq.Tp In [RA_SOH,RA_PRO]) Or
           ((c.Pavi.Seq.Tp=RA_SEP) And (c.Pavi.Seq.Seq[2] In [#$50..#$5F, #$70..#$7F]));
End;

Function  DoExpress( Var c : MinDef ) : Boolean;
Begin
 If (c.Pavi.Seq.Tp In [RA_SOH,RA_PRO]) Or
    ((c.Pavi.Seq.Tp=RA_SEP) And (c.Pavi.Seq.Seq[2] In [#$50..#$5F, #$70..#$7F])) Then
  Begin
   TransCodeSeq(c.Pavi.TC,c.Pavi.Seq.Seq,c.Pavi.Seq.Tp);  { Transcodage si necessaire }

   PaqSendExpress(c.Sys.PaqIn,c.Pavi.Seq.Seq[1],length(c.Pavi.Seq.Seq));

   DoExpress := TRUE;
  End
 Else DoExpress := FALSE;
End;


Function  SeqHangUp( Var c : MinDef ) : Boolean;
Begin
 If (c.Pavi.Seq.Tp=RA_SEP) And (c.Pavi.Seq.Seq[2] In [#$53]) Then
  Begin
   SeqHangUp := TRUE;
  End
 Else SeqHangUp := FALSE;
End;


Function  SeqFin( Var c : MinDef ) : Boolean;
Begin
 SeqFin := (c.Pavi.Seq.Tp=RA_SEP) And (c.Pavi.Seq.Seq[2]=#$49);
End;


Procedure AddEchoStr( Var c : MinDef; Texte : String );
Begin
  If c.Pavi.Echo.Echo And (Length(Texte)<=SizeOf(c.Pavi.Echo.Buf)-c.Pavi.Echo.Lg) Then
  Begin
   Move(Texte[1],c.Pavi.Echo.Buf[c.Pavi.Echo.Lg],Length(Texte));
   Inc(c.Pavi.Echo.Lg,Length(Texte));
  End;
End;


Procedure EchoSeq( Var c : MinDef );
Begin
 { Verifie que la sequence peut etre en ECHO }
 If Not(c.Pavi.Seq.Tp In [RA_SEP,RA_FILT,RA_SOH,RA_PRO,RA_ISO2022]) Then
   AddEchoStr(c,c.Pavi.Seq.Seq);
End;


Procedure EchoFlush( Var c : MinDef );
Begin
 PaqSendData(c.Sys.PaqOut,c.Pavi.Echo.Buf,c.Pavi.Echo.Lg);
 c.Pavi.Echo.Lg := 0;
 c.Pavi.Echo.Flush := FALSE;
End;


Procedure InsertEcho( Var c : MinDef );
Begin
 If (c.Pavi.Echo.Lg>0) And (c.Com.TransmitCount=0) Then EchoFlush(c);
End;


Procedure SendPaviBuf( Var c : MinDef );
Var i : Byte;
Begin
 For i := 1 To Length(c.Pavi.sBuf) Do
  c.Pavi.sBuf[i] := Char(Byte(c.Pavi.sBuf[i]) ANd 127);

 PaqSendExpress(c.Sys.PaqIn,c.Pavi.sBuf[1],length(c.Pavi.sBuf));
 c.Pavi.sBuf[0] := #0;
End;


Procedure AddBufChar( Var c : MinDef; z : Char; NoMore : Boolean );
Begin
 Inc(c.Pavi.sBuf[0]);
 c.Pavi.sBuf[Length(c.Pavi.sBuf)] := z;
 If Length(c.Pavi.sBuf)>=SizeOf(c.Pavi.sBuf)-1 Then
  If NoMore Then SendPaviBuf( c )
  Else SendPaviBuf( c );  { Emettre }
End;


Procedure ClassSeq( Var c : MinDef );
Var i : Byte;
Begin
 If c.Pavi.Seq.Seq<>'' Then
  Begin
   TransCodeSeq(c.Pavi.TC,c.Pavi.Seq.Seq,c.Pavi.Seq.Tp);  { Transcodage si necessaire }

   AddBufChar(c,Char(Byte(c.Pavi.Seq.Seq[1]) Or 128),FALSE);  { Debut de la squence }

   For i := 2 To Length(c.Pavi.Seq.Seq) Do AddBufChar(c,c.Pavi.Seq.Seq[i],FALSE);
  End;
End;


Procedure EnvoiSeq( Var c : MinDef );
Var i : Byte;
Begin
 If c.Pavi.Seq.Seq<>'' Then
  Begin
   TransCodeSeq(c.Pavi.TC,c.Pavi.Seq.Seq,c.Pavi.Seq.Tp);  { Transcodage si necessaire }

   AddBufChar(c,Char(Byte(c.Pavi.Seq.Seq[1]) Or 128),Length(c.Pavi.Seq.Seq)=1);  { Debut de la squence }

   For i := 2 To Length(c.Pavi.Seq.Seq) Do AddBufChar(c,c.Pavi.Seq.Seq[i],Length(c.Pavi.Seq.Seq)=i);

   SendPaviBuf( c );
  End;
End;


Function  DoCorrection( Var c : MinDef ) : Boolean;
Var i : Byte;
Begin
 If (c.Pavi.Seq.Tp=RA_SEP) And (c.Pavi.Seq.Seq[2]=#$47) Then
  Begin
   DoCorrection := TRUE;
   If Length(c.Pavi.sBuf)=0 Then
    Begin { Rien emettre correction ... }
     EnvoiSeq(c);
    End
   Else
    Begin
     i := length(c.Pavi.sBuf);
     While (i>0) And ((Byte(c.Pavi.sBuf[i]) And 128)=0) Do Dec(i);

     If (i>0) Then
      Begin
       c.Pavi.sBuf[0] := Char(i-1);
       AddEchoStr(c,#8' '#8);
      End
     Else
      Begin { Emettre correction quand meme ... }
       EnvoiSeq(c);
      End;
    End;
  End
 Else DoCorrection := FALSE;
End;


Procedure ClearTimeOut( Var c : MinDef );
Var p : PPaviRec;
Begin { Test time out ... }
 p := @c.Pavi;
 p^.Seq.Ti := GetC18;
 p^.Seq.Avert := FALSE;
End;


Procedure CheckTimeOut( Var c : MinDef );
Const Bientot : String[31] = POSLZ+#$1B#$48'bient'#$19#$43#$6F't interrompu'#$0A#$07;
Begin { Test time out ... }
 If (c.Pavi.Seq.Ti=0) Or
    ( (c.Pavi.Seq.NoTimeOut) And (c.Sys.cvon) And Not(c.Sys.Link) ) Then
  Begin
   c.Pavi.Seq.Ti    := GetC18;
   c.Pavi.Seq.Avert := FALSE;
  End
 Else
  If c.Pavi.Seq.Avert Then
   Begin
    If c.Pavi.Seq.Ti+TempoDcnx<=GetC18 Then
     Begin { Fin !!! }
      SysDeco(c.Sys,CAUSE_PAV,$00);
      AbortConnect(c);
     End;
   End
  Else
   If c.Pavi.Seq.Ti+TempoSleep<=GetC18 Then
    Begin
     PaqSendData(c.Sys.PaqOut,Bientot[1],Length(Bientot));
     c.Pavi.Seq.Avert := TRUE;
    End;
End;


Function CreatSeq( Var c : MinDef ) : Boolean;
Var z : Char;
    p : PPaviRec;
Begin
 p := @c.Pavi;

 If (((p^.Seq.Seq='') And (p^.Seq.Aig=VA_NIL)) Or (p^.Seq.Aig<>VA_NIL)) And
   GetComChar(c,z) Then
  Begin
   If DetectComBuf(c,c.Eq.WHangUp) Then
    Begin { Fin detect }
     SysDeco(c.Sys,CAUSE_PAV,$00);
     AbortConnect(c);
     CreatSeq := FALSE;
     Exit;
    End;

   z := Char(Byte(z) And 127);
   If (z<>#0) Or (p^.Seq.Aig=VA_NIL) Then
    Begin
     p^.Seq.Aig := ClassChar(z,p^.Seq.Aig,p^.Seq.Tp);

     Inc(p^.Seq.Seq[0]);
     p^.Seq.Seq[Length(p^.Seq.Seq)] := z;
     If Length(p^.Seq.Seq)>=SizeOf(p^.Seq.Seq)-1 Then
      Begin { Debordement !!!! }
       p^.Seq.Aig := VA_NIL;          { Force fin }
      End;

     If (p^.Seq.Aig=VA_NIL) And Not(SeqAck(c)) Then ClearTimeOut(c);
    End;
  End;
 CreatSeq := TRUE;
End;


Procedure Min_Cnx( Var c : MinDef );
Begin
 If Not(c.Sys.cvon) Then
  Begin
   AbortConnect(c);
  End;

 If CreatSeq(c) Then
  Begin
   If (c.Pavi.Seq.Aig=VA_NIL) And (c.Pavi.Seq.Seq<>'') Then
    Begin { Sequence complete }

     If SeqFin(c) Then
      Begin { Fin de communication (souhait) }
       If c.Pavi.Break Then
        Begin
          { forcer fin physique }
         SysDeco(c.Sys,CAUSE_PAV,$00);
         AbortConnect(c);
        End
       Else
        Begin
         { envoyer le signal "deco" en donnes express!!!! }

         c.Pavi.Break := TRUE;

         TransCodeSeq(c.Pavi.TC,c.Pavi.Seq.Seq,c.Pavi.Seq.Tp);  { Transcodage si necessaire }

         PaqSendExpress(c.Sys.PaqIn,c.Pavi.Seq.Seq[1],length(c.Pavi.Seq.Seq));
        End;
      End
     Else
      Begin
       c.Pavi.Break := FALSE;

       If Not(DoCorrection(c)) Then
        If Not(DoExpress(c)) Then
         If SeqEnvoi(c) Then
          Begin
           c.Pavi.Echo.Flush := TRUE;
           EchoSeq(c);
           EnvoiSeq(c);
          End
         Else
          Begin
           EchoSeq(c);
           ClassSeq(c);
          End;
      End;

     c.Pavi.Seq.Seq := '';
    End;
  End;

 InsertEcho(c);

 CheckTimeOut(c);
End;


Procedure MinExec( Var m : MinDef );
Begin
 Case m.MPos Of
  MPOS_RESET : Min_Reset(m);
  MPOS_WRING : Min_WRing(m);
  MPOS_WCNX  : Min_WCnx(m);
  MPOS_CNX   : Min_Cnx(m);
 Else m.MPos := MPOS_RESET;
 End;
End;

Procedure MinReview;
Var i : Byte;
    m : PMinDef;
Begin
 For i := 1 To MinMax Do
  Begin
   m := TMin[i];
   If m<>NIL Then MinExec(m^);
  End;
End;

Procedure MinVide;
Var i : Byte;
    m : PMinDef;
    dt : String;
    Tp : Byte;
Begin
 For i := 1 To MinMax Do
  If TMin[i]<>NIL Then
   Begin
    m := TMin[i];
    If (m^.Com.TransmitCount<=0) And PaqPop(m^.Sys.PaqOut,Tp,dt) Then
     Begin
      Case Tp Of
       DATA_RESET :
        Begin
         m^.Com.Send(m^.Eq.SConnect[1],Length(m^.Eq.SConnect));
         m^.Com.Send(m^.Eq.SOnLine[1],Length(m^.Eq.SOnLine));
        End;
       Else m^.Com.Send(dt[1],Length(dt));
      End;
     End;
   End;
End;


Procedure MinPolling;
Begin
 MinReview;
 MinVide;
End;


