{ ==== A utiliser 1 fois, au lancement du programme ==== }

Procedure SysInit( Var Sys : MinSys );
Begin
 Sys.PaqIn.First := NIL;
 Sys.PaqIn.Last := NIL;
 Sys.PaqOut.First := NIL;
 Sys.PaqOut.Last := NIL;

 Sys.cvon   := FALSE;

 Sys.IsMaster := FALSE;
End;



(*
  Cherche le maitre de ce NAM...
  renvoi NIL si aucun
  "Id" n'est valide que s'il y a un matre
  MAIS: s'il n'y a pas de matre, il renvoi l'Id d'un "user"
        dj en place... Id=9999 si aucun user.
*)

Function SeekNamSysMaster( Var Nam : NamDef; Var Id : Word ) : PMinSys;
Var i, j : Byte;
    p : PPavDef;
    z : PPavMinDef;
Begin
 Id := 9999;
 For j := 1 To PavMax Do
  If (TPav[j]<>NIL) Then
   Begin
    p := TPav[j];
    For i := 1 To p^.PCfg.MinMax Do
     Begin
      z := p^.TMin[i];
      If (z^.Sys.cvon) And (z^.Sys.CurrentNam=@Nam) Then
       Begin
        If (z^.Sys.IsMaster) Then
         Begin
          Id := z^.Id;
          SeekNamSysMaster := @z^.Sys;
          Exit;
         End;
        If (Id=9999) Then Id := z^.Id;  { le premier... }
       End;
     End;
   End;
 SeekNamSysMaster := NIL;
End;

(*
  Verifie que le NAM existe... s'il existe... renvoi TRUE et:
  Le "MinSys" ayant un droit de mettre sur ce "NAM"
*)

Function SysMaster( nNam : Byte; Var SysM : PMinSys; Var Id : Word ) : Boolean;
Begin
 If (nNam>0) And (nNam<=NamMax) And (TNam[nNam]<>NIL) Then
  Begin
   SysM := SeekNamSysMaster(TNam[nNam]^,Id);
   SysMaster := TRUE;
   Exit;
  End;
 SysMaster := FALSE;
End;



Function SendFile( Var Sys : MinSys; Name : String ) : Boolean;
Var f : File;
    buf : Array[1..512] Of Byte;
    r : Word;
    max : Word;
Begin
 If Name<>'' Then
  Begin
   Assign(f,Name);
   Reset(f,1);
   If IoResult=0 Then
    Begin
     max := 0;
     While Not(Eof(f)) And (max<SIZEMAXFILE) Do
      Begin
       BlockRead(f,buf,sizeof(buf),r);
       PaqSendData(Sys.PaqOut,buf,r);
       Inc(max,r);
      End;
     Close(f);
     SendFile := TRUE;
    End
   Else SendFile := FALSE;
  End
 Else SendFile := FALSE;
End;

Function AfficheVoie( Var Sys : MinSys; Var v : VoieRec ) : Boolean;
Const
      VDCfg : VDispCfg = (
          CSI          : FALSE;   { Optimise deplacement avec CSI }
          OptInvGrp    : TRUE;    { Optimise si invisible }
          GXor         : FALSE;
          OptInvTxt    : TRUE;    { Optimise si invisible }
          OptRepet     : TRUE;    { Optimise si repetition }
          xRep         : FALSE;   { fait toujours prcder le car  repeter }
          ComplAsSpace : TRUE;    { Les complements sont des espaces }
          ForceDelGrp  : FALSE;   { Force ecriture du delimiteur graphik }
          ForceDelTxt  : FALSE;   { Force ecriture du delimiteur texte }
          VideAsSpace  : TRUE;    { ignore les places vides }
          OptWithCan   : TRUE;    { optimise avec le code CAN }
          OptSpclGrp   : TRUE;    { optimisation special avec code #14 }
          OptSpclTxt   : TRUE;    { op avec le code #15 }
          C15Clr       : FALSE;   { #15 n'annule pas le soulignement latent }
          OptMem       : OM_Nothing;
          DebCursor    : FALSE;
          OptNilDRCS   : TRUE;
          NoCR         : FALSE;
          Scroll       : FALSE
        );

Var VD : VDispRec;
    VRam : PVDispRam;
    DRCS : PVDispRamDRCS;
    s : String;
    iY, iX : Byte;
Begin
 AfficheVoie := FALSE;
 If v.ComOn And (v.E.Ram<>NIL) Then
  Begin
   New(VRam);
   If VRam=NIL Then Exit;

   ClearRam(VRam);

   If v.E.DRCS=NIL Then DRCS := NIL
   Else
    Begin
     New(DRCS);
     If DRCS=NIL Then
      Begin
       Dispose(VRam);
       Exit;
      End;
     ClearRamDRCS(DRCS);
    End;

   FillChar(VD,SizeOf(VD),0);
   InitVD(VD,VRam,DRCS,v.E.DRCS);
   VD.Cfg := VDCfg;

   For iY := 0 To ScreenHigh-1 Do
    Begin
     { vide la ligne d'abord... c + bo }
     For iX := 0 To ScreenLong-1 Do
      Begin
       TransCode(VD,iX,iY,#95,AttNothing,s);
       PaqSendData(Sys.PaqOut,s[1],length(s));
      End;

     For iX := 0 To ScreenLong-1 Do
      Begin
       With v.E.Ram^[iY,iX] Do TransCode(VD,iX,iY,Car,Att,s);
       PaqSendData(Sys.PaqOut,s[1],length(s));
      End;
    End;

   FlushTrans(VD,s);
   PaqSendData(Sys.PaqOut,s[1],length(s));

   If v.E.Situ.CurPos Then
    Begin
     s := #$1F+Char(v.E.Situ.Y+64)+Char(v.E.Situ.X+65);
     PaqSendData(Sys.PaqOut,s[1],length(s));
     AttCode(v.E.Situ.Att,Trait+Inverse+Taille,s);
     PaqSendData(Sys.PaqOut,s[1],length(s));
     if v.E.Rdy.CurOffOn then
      Begin
       If v.E.Stat.CurOn Then s := #17
       Else s := #20;
       PaqSendData(Sys.PaqOut,s[1],length(s));
      End;
    End;

   If DRCS<>NIL Then Dispose(DRCS);
   Dispose(VRam);
   AfficheVoie := TRUE;
  End;
End;


Procedure SysLib( Var Sys : MinSys; cause, diag : Byte );
Begin
 If (Sys.cvon) And (Sys.Link) Then
  Begin
   If (Sys.Nam<>NIL) Then
    Begin
     If (Sys.Voie^.ComOn) Then SendLIB(Sys.Nam^,Sys.nVoie,cause,diag)
     Else ClrLink(Sys.Voie^,cause,diag);
    End;
  End;
End;


Procedure OutClrLZ( Var Sys : MinSys );
Const ClrLZ   : String[07] = POSLZ+#$0A;
Begin
 PaqSendData(Sys.PaqOut,ClrLZ[1],Length(ClrLZ));
(* c.Pavi.LZ := FALSE; *)
End;



Procedure OutLZ( Var Sys : MinSys; texte : String );
Var s : String;
Begin
 s := POSLZ+texte+#10;
 PaqSendData(Sys.PaqOut,s[1],length(s));
(* c.Pavi.LZ := TRUE; *)
End;

Procedure OutLib( Var Sys : MinSys; cause, diag : byte );
Begin
 OutLZ(Sys,'LIB '+Byte2Hex(cause)+'/'+Byte2Hex(diag));
End;


Procedure OutLZErr( Var Sys : MinSys );
Begin
 OutLZ(Sys,'ERREUR');
End;

Procedure OutLZOk( Var Sys : MinSys );
Begin
 OutLZ(Sys,'OK');
End;


Procedure CreatLink( Var Sys : MinSys; Var n : NamDef; nv : Byte );
Begin
 Sys.Link := TRUE;
 Sys.Nam := @n;
 Sys.Voie := @n.TabVoies[nv];
 Sys.nVoie := nv;
 Sys.CnxTimeOut := GetC18+Sys.TCnx; { 18*5; }
End;

Procedure KillLink( Var Sys : MinSys );
Begin
 Sys.Link := FALSE;
 Sys.Nam := NIL;
 Sys.Voie := NIL;
 Sys.nVoie := 0;
End;

Function MinConnect( Var Sys : MinSys; Var n : NamDef; Var s : String; NoLink : Boolean ) : Boolean;
Var i, j : Byte;
    v : PVoieRec;
Begin
 For j := NbVoies-1 DownTo 0 Do
  Begin
   If EnReso Then
    Begin
     (* Inverser l'ordre de recherche des voies libres! *)
     i := (NbVoies-1)-j;
    End
   Else i := j;

   v := @n.TabVoies[i];

   If ( ( (v^.LastCnxC18<>0) And (v^.LastCnxC18<=GetC18) ) Or (v^.CStr='')) And Not(v^.ComOn) Then
    Begin
     CheckRefresh(n);

     v^.LastCnxC18 := GetC18+15*18;     (* 15 secondes maxi... *)
     v^.SaveCStr := v^.CStr;
     v^.CStr := s;
     If Not(NoLink) Then CreatLink(Sys,n,i);

     If ExecCall(n,i) Then
      Begin
       MinConnect := TRUE;
       Exit;
      End;

     v^.CStr := v^.SaveCStr;
     If Not(NoLink) Then KillLink(Sys);

     Break;         (* Erreur!!!! inutile de continuer! *)

    End;
  End;
 MinConnect := FALSE;
End;

Procedure MCmdVBIP( Var Sys : MinSys; Var sp : String );
Var n : Word;
Begin
 If StrVal(sp,1,n,1) Then
  Begin
   If n>20 Then n := 20;
   While n>0 Do
    Begin
     Beep;
     Dec(n);
    End;
   OutLZOk(Sys);
  End
 Else OutLZErr(Sys);
End;

Procedure MCmdVNAM( Var Sys : MinSys; Var sp : String );
Var n : Word;
Begin
 If StrVal(sp,1,n,0) And (n>=1) And (n<=NamMax) And ChangeNam(n) Then OutLZOk(Sys)
 Else OutLZErr(Sys);
End;

Function StrVoie( Var sp : String; npar : Byte; Var result : Word ) : Boolean;
Var n : Word;
    s : String[1];
Begin
 If StrVal(sp,npar,n,$FFFF) Then
  Begin
   If (n>=0) And (n<NbVoies) Then
    Begin
     result := n;
     StrVoie := TRUE;
     Exit;
    End;
  End
 Else
  If StrStr(sp,npar,s,SizeOf(s)-1) And (s<>'') Then
   Begin
    n := Word(Byte(UpCase(s[1]))-Byte('A')+10);
    If (n>=0) And (n<NbVoies) Then
     Begin
      result := n;
      StrVoie := TRUE;
      Exit;
     End;
   End;
 StrVoie := FALSE;
End;

Procedure MCmdVVOIE( Var Sys : MinSys; Var sp : String );
Var n : Word;
    s : String[1];
Begin
 If StrVoie(sp,1,n) Then
  Begin
   ChangeVoie(NamScr^,n);
   OutLZOk(Sys);
  End
 Else
  If StrStr(sp,1,s,SizeOf(s)-1) Then
   Begin
    If s='+' Then ChangeDownVoie(NamScr^)
    Else
     If s='-' Then ChangeUpVoie(NamScr^)
     Else OutLZErr(Sys)
   End
  Else OutLZErr(Sys);
End;

Procedure MCmdVRAF( Var Sys : MinSys; Var sp : String );
Begin
 Refresh := TRUE;
 OutLZOk(Sys);
End;

Procedure MCmdNAM( Var Sys : MinSys; Var sp : String );
Var n : Word;
    Id : Word;
Begin
 If StrVal(sp,1,n,0) And (n>=1) And (n<=NamMax) And (TNam[n]<>NIL) Then
  Begin
   If (Sys.IsMaster) Then OutLZ(Sys,'ERREUR: YOU ARE LOCKED !')
   Else
    If (SeekNamSysMaster(TNam[n]^,Id)=NIL) Then
     Begin
      Sys.CurrentNam := TNam[n];
      OutLZOk(Sys);
     End
    Else OutLZ(Sys,'ERREUR: IT''S LOCK !');
  End
 Else OutLZErr(Sys);
End;

Procedure MCmdSPD( Var Sys : MinSys; Var sp : String );
Var v : LongInt;
    s : String;
    Nam : PNamDef;
Begin
 If (Sys.CurrentNam<>NIL) Then
  Begin
   Nam := Sys.CurrentNam;
   If StrValLong(sp,1,v,0) And (
       (v=4800) Or (v=9600) Or (v=19200) Or (v=38400) Or
       ( (Nam^.NCfg.HiSpd) And ( (v=57600) Or (v=115200) ) )
      ) Then
    Begin
     Nam^.Com.Done;

     Nam^.Cfg.Spd := v;

     Nam^.Com.Init(Nam^.Cfg.UART,Nam^.Cfg.IRQ,
                   Nam^.Cfg.Spd,Nam^.Cfg.Par,Nam^.Cfg.BufIn,Nam^.Cfg.BufOut);
    End;

   s := 'VITESSE: '+Val2Str(Nam^.Cfg.Spd,1)+' Bauds';
   OutLZ(Sys,s);
  End
 Else OutLZErr(Sys);
End;

Procedure LineInfo( Var Nam : NamDef; Var s : String; courant : byte );
Var i : Byte;
    v : PVoieRec;
Begin
 s := 'NAM '+_Val2Str(Nam.nNam,0)+' : ';
 For i := 0 To NbVoies-1 Do
  Begin
   v := @Nam.TabVoies[i];
   If v^.ComOn Then
    Begin
     s := s+#27#93;
     if (courant<>$FF) And (courant<>i) Then s := s+#27#66;
    End;
   If i<10 Then s := s+char(i+Byte('0'))
   Else s := s+char(i-10+Byte('A'));
   If v^.ComOn Then
    Begin
     s := s+#27#92;
     if (courant<>$FF) And (courant<>i) Then s := s+#27#71;
    End;
  End;
End;

Procedure MCmdInfo( Var Sys : MinSys; Var sp : String );
Var s : String;
Begin
 LineInfo(Sys.CurrentNam^,s,$FF);
 OutLZ(Sys,s);
End;

Function MCmdShow( Var Sys : MinSys; Var sp : String ) : Boolean;
Var v : PVoieRec;
    n : Word;
Begin
 If StrVoie(sp,1,n) Then
  Begin
   v := @Sys.CurrentNam^.TabVoies[n];
   If v^.ComOn Then
    Begin
     If AfficheVoie(Sys,v^) Then
      Begin
       MCmdShow := TRUE;
       Exit;
      End
     Else OutLZErr(Sys);
    End
   Else OutLZ(Sys,'VOIE NON CONNECTEE');
  End
 Else OutLZErr(Sys);
 MCmdShow := FALSE;
End;


{ Renvoi TRUE si le lien est actif ! }

Function MCmdCall( Var Sys : MinSys; Var sp : String; NoLink : Boolean ) : Boolean;
Var s : String;
Begin
 s := ConvertNAB(sp);

 If MinConnect(Sys,Sys.CurrentNam^,s,NoLink) Then
  Begin
   OutLZ(Sys,'APPEL: '+s);
   If NoLink Then MCmdCall := FALSE
   Else MCmdCall := TRUE;
   Exit;
  End;
 OutLZErr(Sys);
 MCmdCall := FALSE;
End;


Procedure MCmdCnx( Var Sys : MinSys; Var sp : String );
Var s : String;
    x : Word;
    h : Word;
Begin
 If StrStr(sp,1,s,SizeOf(s)-1) And
    StrVal(sp,2,x,0) Then
  Begin
   s := ConvertNAB(s);

   If (x<1) Then x := 1
   Else If (x>NbVoies) Then x := NbVoies;

   h := 0;
   While(x<>0) Do
    Begin
     If MinConnect(Sys,Sys.CurrentNam^,s,TRUE) Then
      Begin
       Dec(x);
       Inc(h);
      End
     Else Break;
    End;

   If (h<>0) Then OutLZ(Sys,'APPEL: '+s)
   Else OutLZErr(Sys);
  End
 Else OutLZErr(Sys);
End;


{ Renvoi TRUE si un lien est en cous }

Function MCmdMem( Var Sys : MinSys; Var sp : String ) : Boolean;
Var n : Word;
Begin
 If StrVal(sp,1,n,$FFFF) And (n>=0) And (n<NbCStr) And (TabCStr[n]<>'') Then
  Begin
   MCmdMem := MCmdCall(Sys,TabCStr[n],FALSE);
   Exit;
  End;
 OutLZErr(Sys);
 MCmdMem := FALSE;
End;

Procedure MCmdClr( Var Sys : MinSys; Var sp : String );
Var i : Byte;
Begin
 For i := 0 To NbVoies-1 Do
  If Not(Sys.CurrentNam^.TabVoies[i].ComOn) Then
   Sys.CurrentNam^.TabVoies[i].CStr := '';
 CheckRefresh(Sys.CurrentNam^);
 OutLZOk(Sys);
End;


{ Renvoi TRUE si le lien est fait }
{ Renvoi FALSE si le lien est en cours... (nuuuuance!) }

Function DoLink( Var Sys : MinSys; nv : Word ) : Boolean;
Var v : PVoieRec;
Begin
 v := @Sys.CurrentNam^.TabVoies[nv];
 CreatLink(Sys,Sys.CurrentNam^,nv);
 If v^.ComOn Then
  Begin
   AfficheVoie(Sys,v^);
   OutLZ(Sys,'VOIE '+_Val2Str(nv,0));
   DoLink := TRUE;
  End
 Else
  Begin
   OutLZ(Sys,'LIEN EN COURS VOIE '+_Val2Str(nv,0)+' ...');
   DoLink := FALSE;
  End;
End;

{ Renvoi TRUE si lien fait ... sinon FALSE }

Function MCmdLink( Var Sys : MinSys; Var sp : String ) : Boolean;
Var n : Word;
Begin
 If StrVoie(sp,1,n) Then
  Begin
   DoLink(Sys,n);
   MCmdLink := TRUE;
   Exit;
  End
 Else OutLZErr(Sys);
 MCmdLink := FALSE;
End;

Procedure MCmdDeco( Var Sys : MinSys; Var sp : String );
Var n : Word;
    v : PVoieRec;
    i : Byte;
    s : String;
Begin
 If StrVoie(sp,1,n) Then
  Begin
   v := @Sys.CurrentNam^.TabVoies[n];
   If v^.ComOn Then
    Begin
     SendLIB(Sys.CurrentNam^,n,CAUSE_PAV,$01);
     OutLZOk(Sys);
    End
   Else OutLZErr(Sys);
  End
 Else
  Begin
   StrStr(sp,1,s,SIzeOf(s)-1);
   If s='*' then
    Begin
     n := 0;
     For i := 0 To NbVoies-1 Do
      Begin
       v := @Sys.CurrentNam^.TabVoies[i];
       If v^.ComOn Then
        Begin
         Inc(n);
         SendLIB(Sys.CurrentNam^,i,CAUSE_PAV,$01);
        End;
      End;
     OutLZ(Sys,_Val2Str(n,0)+' VOIE(S) DECONNECTEE(S)');
    End
   Else OutLZErr(Sys);
  End;
End;


{ extrait voie suivant:  #<voie> }

Function ExtractVoie( Var d : String; dvoie : Word ) : Word;
Var s : String;
    n : Word;
    Err : Word;
Begin
 s := copy(d,2,length(d)-1);

 If s='' Then
  Begin
   n := dvoie;
   Err := 0;
  End
 Else
  Begin
   Val(s,n,Err);
   If (Err<>0) Then
    If (Length(s)=1) Then
     Begin
      n := Word(Byte(UpCase(s[1]))-Byte('A')+10);
      Err := 0;
     End
    Else n := $FFFF;    { c'est une erreur }
  End;

 ExtractVoie := n;
End;


{ #voie [Guide] }
{ Renvoi TRUE si le lien est fait ou en cours... }
{ sinon renvoi FALSE avec: Ok=TRUE si la commande est traite, Ok=FALSE si non trait }

Function MCmdFastLIEN( Var Sys : MinSys; Var sp : String; Var Ok : Boolean ) : Boolean;
Var n : Word;
    s : String;
Begin
 If (sp<>'') And (sp[1]='#') Then
  Begin
   Ok := TRUE;
   If length(sp)=1 Then
    Begin
     LineInfo(Sys.CurrentNam^,s,$FF);
     OutLZ(Sys,s);
    End
   Else
    Begin
     n := ExtractVoie(sp,$FFFF);
     If (n>=0) And (n<NbVoies) Then
      Begin
       DoLink(Sys,n);
       MCmdFastLIEN := TRUE;
       Exit;
      End
     Else OutLZErr(Sys);
    End;
  End
 Else Ok := FALSE;
 MCmdFastLIEN := FALSE;
End;

{ #voie [Repetition] }

Function MCmdFastSHOW( Var Sys : MinSys; Var sp : String; Var Ok : Boolean ) : Boolean;
Var n : Word;
    v : PVoieRec;
Begin
 If (sp<>'') And (sp[1]='#') Then
  Begin
   Ok := TRUE;
   n := ExtractVoie(sp,$FFFF);
   If (n>=0) And (n<NbVoies) Then
    Begin
     v := @Sys.CurrentNam^.TabVoies[n];
     If v^.ComOn Then
      Begin
       If AfficheVoie(Sys,v^) Then
        Begin
         MCmdFastSHOW := TRUE;
         Exit
        End
       Else OutLZErr(Sys);
      End
     Else OutLZ(Sys,'VOIE NON CONNECTEE');
    End
   Else OutLZErr(Sys);
  End
 Else Ok := FALSE;
 MCmdFastSHOW := FALSE;
End;

{ Renvoi TRUE si la commande a fait evoluer l'etat du cv vers un lien!!! }
{ Renvoi FALSE pour X autres raisons... }

Function MinCommande( Var Sys : MinSys; s : String; Var _Clr : Boolean ) : Boolean;
Var i : Byte;
    n : Byte;
    p : String[8];
    Clr, Link : Boolean;
    Sauve : String;
Begin

 i := 1;
 While (i<SizeOf(p)) ANd (i<=Length(s)) And (s[i]<>' ') Do
  Begin
   p[i] := UpCase(s[i]);
   Inc(i);
  End;

 p[0] := Char(i-1);

 Link := FALSE;         { par defaut... }
 Clr := TRUE;

 If p='' Then
  Begin
   OutLZ(Sys,'MAUVAISE SYNTAXE');
  End
 Else
  If p[1]='#' Then
   Begin
    Sauve := s;
    Delete(s,1,length(p)+1);
    If p='#VBIP' Then MCmdVBIP(Sys,s)
    Else
     If p='#VNAM' Then MCmdVNAM(Sys,s)
     Else
      If p='#VVOIE' Then MCmdVVOIE(Sys,s)
      Else
       If p='#VRAF' Then MCmdVRAF(Sys,s)
       Else
        If p='#NAM' Then MCmdNAM(Sys,s)
        Else
         If p='#INFO' Then MCmdINFO(Sys,s)
         Else
          If p='#VOIR' Then Clr := Not(MCmdShow(Sys,s))
          Else
           If p='#MEM' Then
            Begin
             If MCmdMem(Sys,s) Then Link := TRUE;
            End
           Else
            If p='#APPEL' Then
             Begin
              If MCmdCall(Sys,s,FALSE) Then Link := TRUE;
             End
            Else
             If p='#EFF' Then MCmdClr(Sys,s)
             Else
              If p='#CNX' Then MCmdCnx(Sys,s)
              Else
               If (p='#LIEN') Or (p='#') Then
                Begin
                 If MCmdLink(Sys,s) Then Link := TRUE;
                End
               Else
                If p='#DECO' Then MCmdDeco(Sys,s)
                Else
                 If p='#SPD' Then MCmdSpd(Sys,s)
                 Else
     Begin
      (* OutLZ(Sys,'COMMANDE INCONNUE'); *)
      If MCmdCall(Sys,Sauve,FALSE) Then Link := TRUE;
     End;
   End
  Else If MCmdCall(Sys,s,FALSE) Then Link := TRUE;

 _Clr := Clr;

 MinCommande := Link;
End;


{ traitement des commandes speciales en cours de communication }
{ #<n> [Tche Fonction] }

Procedure CmdJoker( Var Sys : MinSys; Var d : String; tche : Char );
Var s : String;
    n : Word;
    v : PVoieRec;
    Nam : PNamDef;
Begin
 OutLZ(Sys,#27'G '#13#27'U '#13#27'G '#13#27'U '#13#27'G '#13#27#93#24);

 n := ExtractVoie(d,Sys.nVoie);

 If (n>=0) And (n<NbVoies) Then
  Begin
   Case tche Of
    T_REPETITION :
     Begin { affiche une emulation }
      v := @Sys.Nam^.TabVoies[n];
      PaqFlush(Sys.PaqOut);
      PaqFlush(Sys.PaqIn);
      If v^.ComOn Then
       Begin
        If AfficheVoie(Sys,v^) Then Exit
        Else OutLZErr(Sys);
       End
      Else OutLZ(Sys,'VOIE NON CONNECTEE');
     End;
    T_GUIDE :
     If n=Sys.nVoie Then
      Begin
       PaqFlush(Sys.PaqOut);
       PaqFlush(Sys.PaqIn);
       LineInfo(Sys.Nam^,s,n);
       OutLZ(Sys,s);
      End
     Else
      Begin { changement de lien }
       PaqFlush(Sys.PaqOut);
       PaqFlush(Sys.PaqIn);
       v := @Sys.Nam^.TabVoies[n];
       If v^.ComOn Then
        Begin
         If AfficheVoie(Sys,v^) Then
          Begin
           Nam := Sys.Nam;
           KillLink(Sys);
           CreatLink(Sys,Nam^,n);
           Sys.iPos := 100;
           OutLZ(Sys,'VOIE '+_Val2Str(n,0));
           Exit;
          End
         Else OutLZErr(Sys);
        End
       Else OutLZ(Sys,'VOIE NON CONNECTEE');
      End;
    T_SOMMAIRE :
     Begin { annule le lien en cours , sans deconnecter }
      PaqFlush(Sys.PaqOut);
      PaqFlush(Sys.PaqIn);
      KillLink(Sys);
      Sys.LibCause := 0;
      Sys.LibDiag := 0;
      Sys.iPos := 200;
     End;
   Else OutLZ(Sys,'TOUCHE NON TRAITEE');
   End;
  End
 Else
  Begin
   OutLZ(Sys,'ERREUR DE SYNTAXE');
  End;
End;




Procedure SysDeco( Var Sys : MinSys; Cause : Byte; Diag : Byte );
Begin
 If Sys.cvon Then
  Begin
   PaqFlush(Sys.PaqIn);
   PaqFlush(Sys.PaqOut);
   If (Sys.IsMaster) And (Sys.CurrentNam<>NIL) Then
    Begin { dsactive l'effet du mot de passe }
     Sys.CurrentNam^.Passe := '';
    End;
  End;

 If Sys.Link Then SysLib(Sys,Cause,Diag);

 Sys.cvon   := FALSE;
 Sys.iPos   := 0;
 Sys.Link   := FALSE;
 Sys.Nam    := NIL;
 Sys.nVoie  := 0;
 Sys.Voie   := NIL;
 Sys.nGuide := 0;

 Sys.IsMaster := FALSE;

 Sys.LibCause := 0;
 Sys.LibDiag := 0;
End;



Procedure SysConnect( Var Sys : MinSys; MainNam : Byte );
Begin
 SysDeco(Sys,0,0);
 Sys.cvon := TRUE;

 If (MainNam<>0) And (TNam[MainNam]<>NIL) Then Sys.CurrentNam := TNam[MainNam]
 Else Sys.CurrentNam := NamScr;
End;


Procedure SimGuide( Var Sys : MinSys );
Var s : String;
Begin
 While Sys.nGuide>0 Do
  Begin
   s := FileSeek(Sys.Page.Guide+'.'+Val2Str(Sys.nGuide,3));
   If s<>'' Then
    Begin
     SendFile(Sys,FileSeek(Sys.Page.Guide+'.000'));
     SendFile(Sys,s);
     Exit;
    End;
   Dec(Sys.nGuide);
  End;
End;

Procedure SimRepetition( Var Sys : MinSys );
Begin
 SendFile(Sys,FileSeek(Sys.Page.Page));
 SimGuide(SYs);
End;

Procedure CnxRefresh( Var Sys : MinSys );
Var s : String;
Begin
 OutClrLZ(Sys);
 SimRepetition(Sys);
 s := 'NAMSIM (C) 1993,94 ';
 If Fermic Then s := s+'Fermic Edt. & ';
 s := s+'TJ';
 OutLZ(Sys,s);
End;

Procedure ClrInput( Var Sys : MinSys );
Var  s : String[20];
Begin
 s := #31+Char(64+Sys.Page.Lig)+Char(64+Sys.Page.Col)+'.'+Char(18)+Char(63+Sys.Page.Lg)+
      #31+Char(64+Sys.Page.Lig)+Char(64+Sys.Page.Col)+#17;
 PaqSendData(Sys.PaqOut,s[1],Length(s));
End;



Function DetectFin( Var s : String ) : Boolean;
Begin
 DetectFin := (s=#19'I');
End;

Function GetSaisie( Var Sys : MinSys; Var Dest : String; Var Tche : Char ) : Boolean;
Var Tp : Byte;
Begin
 If PaqPop(Sys.PaqIn,Tp,Dest) Then
  If DetectFin(Dest) Then SysDeco(Sys,CAUSE_PAV,$08)
  Else
   Begin
    If (Length(Dest)>=2) And (Dest[length(Dest)]=#13) Then
     Begin
      tche := Dest[length(Dest)-1];
      dec(Dest[0],2);
     End
    Else tche := #0;
    GetSaisie := TRUE;
    Exit;
   End;
 GetSaisie := FALSE;
End;


Procedure SysExec( Var Sys : MinSys );
Var s : String;
    tche : Char;
    Clr : Boolean;
    Ok : Boolean;
    Tp : Byte;
    i : Word;
Begin
 Case Sys.iPos Of
  0 :
   Begin
    PaqFlush(Sys.PaqOut);
    PaqFlush(Sys.PaqIn);
    PaqSendReset(Sys.PaqOut);
    CnxRefresh(Sys);
    Inc(Sys.iPos);
   End;
  1 :
   Begin
    ClrInput(Sys);
    Inc(Sys.iPos);
   End;
  2 :
   Begin
    If GetSaisie(Sys,s,tche) Then
     Begin
      Sys.iPos := 1;    { par dfaut... }
      Case tche Of
       T_REPETITION :
        Begin
         Clr := Not(MCmdFastSHOW(Sys,s,Ok));

         If Not(Ok) Then Sys.iPos := 0
         Else If Not(Clr) Then Sys.iPos := 2;

        End;
       T_ENVOI : If MinCommande(Sys,s,Clr) Then Sys.iPos := 100   { lien en cours!!! }
                 Else If Not(Clr) Then Sys.iPos := 2;
       T_GUIDE :
        Begin
         If MCmdFastLIEN(Sys,s,Ok) Then Sys.iPos := 100 { lien en cours!!! }
         Else
          Begin
           If Not(Ok) Then
            Begin
             If Sys.nGuide=0 Then
              Begin
               Sys.nGuide := 1;
               SimGuide(Sys);
              End
             Else
              Begin
               Sys.nGuide := 0;
               Sys.iPos := 0;
              End;
            End;
          End;
        End;
       T_SOMMAIRE :
        Begin
         If Sys.nGuide<>0 Then
          Begin
           Sys.nGuide := 1;
           SimGuide(Sys);
          End;
        End;
       T_SUITE :
        Begin
         If Sys.nGuide<>0 Then
          Begin
           Inc(Sys.nGuide);
           SimGuide(Sys);
          End;
        End;
       T_RETOUR :
        Begin
         If Sys.nGuide<>0 Then
          Begin
           If Sys.nGuide>1 Then Dec(Sys.nGuide);
           SimGuide(Sys);
          End;
        End;
      End;
     End;
   End;

  100 :
   Begin { lien actif avec une voie... }
    If Sys.Link Then
     Begin
      If Not(Sys.Voie^.ComOn) And (Sys.CnxTimeOut<=GetC18) Then SysLib(Sys,CAUSE_PAV,$04)
      Else
       If PaqPop(Sys.PaqIn,Tp,s) Then
        If DetectFin(s) Then SysLib(Sys,CAUSE_PAV,$08)
        Else
         If Sys.Voie^.ComOn Then
          Begin
           If (length(s)>=2) And (s[length(s)]=#13) Then
            Begin
             tche := s[length(s)-1];
             if (s[1]='#') And (tche in [T_SOMMAIRE,T_GUIDE,T_REPETITION]) And
                (length(s)<=3+2) Then
              Begin
               dec(s[0],2);
               { traiter le cas particulier... }
               CmdJoker(Sys,s,tche);
               Exit;
              End;
             For i := 1 To Length(s)-2 Do Emul(Sys.Voie^,s[i]);
(*             LinkTrameDon(Sys.Voie^,s[1],length(s)-2); *)
            End
           Else
            Begin
             EmulStr(Sys.Voie^,s);
(*             LinkTrameDon(Sys.Voie^,s[1],length(s)); *)
            End;
           SendTrame(Sys.Nam^,Sys.nVoie,A_DON,s);
          End;
     End
    Else
     Begin
      PaqSendReset(Sys.PaqOut);
      OutLZ(Sys,'Buuug!');
      SimRepetition(Sys);
      Sys.iPos := 1;
     End;
   End;
  200 :
   Begin
    PaqFlush(Sys.PaqOut);
    PaqFlush(Sys.PaqIn);
    PaqSendReset(Sys.PaqOut);
    OutLib(Sys,Sys.LibCause,Sys.LibDiag);
    SimRepetition(Sys);
    Sys.iPos := 1;
   End;
 Else Sys.iPos := 0;
 End;
End;


Procedure SysMinReview;
Var i : Byte;
    m : PMinDef;
Begin
 For i := 1 To MinMax Do
  Begin
   m := TMin[i];
   If m<>NIL Then
    Begin
     If m^.Sys.cvon Then SysExec(m^.Sys);
    End;
  End;
End;


Procedure SysPavReview;
Var i, j : Byte;
    p : PPavDef;
    m : PPavMinDef;
Begin
 For i := 1 To PavMax Do
  Begin
   p := TPav[i];
   If p<>NIL Then
    Begin
     For j := 1 To p^.PCfg.MinMax Do
      Begin
       m := p^.TMin[j];
       If m^.Sys.cvon Then
        Begin
         SysExec(m^.Sys);
        End;
      End;
    End;
  End;
End;



Procedure SysPolling;
Begin
 SysMinReview;
 SysPavReview;
End;


{ -------------------- }

