{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit XDLib;

Interface

Uses XSer,XSerDigi;


Const UseETB : Boolean = TRUE;

Const LG_DON    = 8192; { 128; } { longueur max d'un paquet de donnees }



Const STX    = $02;
      ETX    = $03;
      ETB    = $17;

      RLOG_BASE = $21; { le premier numero logique de reso... }

      A_EDIT    = $25;

      A_ENDR    = $28;
      A_ROUT    = $29;

      A_RESO    = $2F; { trame de reso : spcial!!! }

      A_DON     = $30; { trame de donnees }
      A_APPEL   = $31; { trame d'appel }
      A_LIB     = $32; { trame de libration }
      A_COMM    = $33; { trame de communication tablie }
      A_ERRM    = $34; { trame d'erreur de multiplexage }
      A_INDI    = $35; { trame d'indication d'indisponibilit }
      A_DISP    = $36; { trame d'indication de disponibilit }
      A_ECHOOFF = $37; { trame de suppression d'echo }
      A_ECHOON  = $38; { trame de positionnement d'echo }
      A_INDINAM = $39; { trame d'insponibilite de la carte Namtel }
      A_DONQ    = $3A; { trame de donnees avec bit qualificateur }
      { ... }
      A_RESET   = $3E; { trame de redemarrage }
      A_INCO    = $3F; { trame d'incoherence paquet de donnees }
      A_DISPNAM = $40; { trame de disponibilite de la carte Namtel }

const { C_TRAMA & CO }
      TR_GET_STX    = 0;    { phase de recherche de STX (02h) }
      TR_GET_ENTETE = 1;    { phase de recherche de l'entete (2 ou 4 octet) }
      TR_GET_DON    = 2;    { phase de ramassage (si CL_Exist=TRUE) }
      TR_GET_ET     = 3;    { phase saisie donnees jusqu'a ETX ou ETB }


Type ComNam = Object(ComXD)

         { config... }
         CL_Exist    : Boolean;
         LG_ENTETE   : Byte;
         { valide seulement si TrameIn renvoi TRUE }
         C_TRAMA  : byte; { les differentes niveau de saisie de la trame en cours }
         C_TM     : byte; { type de message (trame) courant }
         C_NT     : byte; { numro terminal courant }
         C_CL1    : byte; { histoire de connaitre son contenu }
         C_CL0    : byte; { idem }
         C_LgWait : Word; { longueur donnees attendu (manquant) (si CL_Exist=TRUE) }
         C_LgDon  : Word; { longueur de donnees }
         C_Don    : array[0..LG_DON-1] of byte; { donnees courante }
         C_ET     : byte; { code de fin de trame recu }

         Function  Init( UART : Word;
                         IRQ : Byte;
                         Spd : LongInt;
                         Par : Byte;
                         BufIn : Word;
                         BufOut : Word ) : Boolean;
         Procedure Done;

         Function GetByte : Byte;
         Function InNb : Word;
         Function Saisie : boolean;
         Procedure PutByte( b : Byte );
         Procedure _PutTrame( NT, TM : Byte; Var p; len : Word );
         Procedure PutTrame( NT, TM : Byte; Var Don : String );
       End;

     ComMin = Object(ComXD)
         Function  Init( UART : Word;
                         IRQ : Byte;
                         Spd : LongInt;
                         Par : Byte;
                         BufIn : Word;
                         BufOut : Word ) : Boolean;
         Procedure Done;
         Procedure Send( Var p; lg : Word );
       End;

Function CheckInit( HiSpeed : Word ) : Boolean;
Procedure CheckDone;

Implementation



Function  CalcCheckUpSpeed( Baud : Word ) : Byte; Assembler;
Asm
    MOV  AX, 640
    XOR  DX, DX
    DIV  [Baud]
    MOV  CL, 16
@ENCORE:
    SHL  AX, 1
    JC   @FIN
    LOOP @ENCORE
@FIN:
    MOV  AL, CL
End;


Function CheckInit( HiSpeed : Word ) : Boolean;
Var Speed : Word;
Begin
 If HiSpeed=0 Then CheckInit := TRUE
 Else
  Begin
   Speed := 115200 Div HiSpeed;

   CheckInit := InstCheckUp(CalcCheckUpSpeed(Speed));
  End;
End;

Procedure CheckDone;
Begin
 KillCheckUp;
End;

Function  ComNam.Init( UART : Word; IRQ : Byte;
                       Spd : LongInt;
                       Par : Byte;
                       BufIn : Word;
                       BufOut : Word ) : Boolean;
Begin
 If (UART<>0) Then
  Begin
   If ComXD.Init(UART,IRQ,115200 Div Spd,Par,BufIn,BufOut) Then
    Begin
     C_TRAMA := TR_GET_STX;
     Init := TRUE;
    End
   Else Init := FALSE;
  End
 Else Init := FALSE;
End;


Procedure  ComNam.Done;
Begin
 ComXD.Done;
End;


Function ComNam.GetByte : Byte;
Var c : Char;
Begin
 While Not(ReceiveChar(c)) Do;
 GetByte := Byte(c);
End;


Function ComNam.InNb : Word;
Begin
 InNb := CCount;
End;

function ComNam.Saisie : boolean;
{ const s_ms1 : string[03] = 'ETX'; }
var i : Word;
label plus,plus1,plus2;
begin
  Saisie := FALSE; { par dfaut }
  if InNb>0 then
    begin
      case C_TRAMA of
        TR_GET_STX :
          begin
            repeat
              i := GetByte;
              if i=STX then
                begin
                  C_TRAMA := TR_GET_ENTETE;
(*
                  If @Nam=NamScr Then WrtDt(9,0,0,CRvs);
*)
                  goto plus;
                end;
            until (InNb=0);
          end;
        TR_GET_ENTETE :
          begin
plus:       if InNb>=LG_ENTETE then
              begin { en tete entier dans le buffer }
                C_TM  := GetByte; { type de trame }
                C_NT  := GetByte; { numro terminal (voie) }
                if CL_Exist then
                  begin
                    C_CL1 := GetByte; { CL1 }
                    C_CL0 := GetByte; { CL0 }
                    { nombre attendu }
                    C_LgWait := (C_CL1 and 1)*128+(C_CL0 and 127);
                    C_LgDon := 0;
                    C_TRAMA := TR_GET_DON;
                    if InNb>0 then goto plus1;
                  end
                else
                  begin
                    C_LgDon := 0;    { pour la suite }
                    C_TRAMA := TR_GET_ET;
                    if InNb>0 then goto plus2;
                  end;
                exit;
              end;
          end;
        TR_GET_DON : { cas pour seulement si CL_Exist=TRUE }
          begin
plus1:      if InNb>=C_LgWait then
              begin { donnes complete! }
                { on les ramasses et on continue }
                while (C_LgWait>0) and (C_LgDon<LG_DON) do
                  begin
                    C_Don[C_LgDon] := GetByte;
                    Inc(C_LgDon);
                    Dec(C_LgWait);
                  end;
                C_TRAMA := TR_GET_ET;
                if InNb>0 then goto plus2;
                exit;
              end;
          end;
        TR_GET_ET :
          begin
plus2:      repeat
              i := GetByte;
              if (i=ETX) or (UseETB And (i=ETB)) then
                begin
                  C_ET := i; { on conserve le fin de trame recu }
                  C_TRAMA := TR_GET_STX; { on boucle }
(*
                  If @Nam=NamScr Then WrtDt(32,0,0,CRvs);
*)
                  Saisie := TRUE;
                  exit;
                end;
              if (C_LgDon<LG_DON) then
                begin
                  C_Don[C_LgDon] := i;
                  inc(C_LgDon);
                end;
            until InNb=0;
          end;
      end;
    end;
end;


Procedure ComNam.PutByte( b : Byte );
Begin
 While Not(TransmitChar(Char(b))) Do ;
End;


Procedure ComNam._PutTrame( NT, TM : Byte; Var p; len : Word );
Var i : Word;
    Don : Array[1..10000] Of Char Absolute p;
Begin
 PutByte(STX);
 PutByte(TM);
 PutByte(NT);
 If CL_Exist Then
  Begin
   PutByte(len Div 128);  { CL1 }
   PutByte(len And 127);  { CL0 }
  End;
 For i := 1 To len Do
  If CL_Exist Or (Don[i]>#3) Then PutByte(Byte(Don[i]));
 PutByte(ETX);
End;



Procedure ComNam.PutTrame( NT, TM : Byte; Var Don : String );
Var i : Word;
Begin
 PutByte(STX);
 PutByte(TM);
 PutByte(NT);
 If CL_Exist Then
  Begin
   PutByte(length(Don) Div 128);  { CL1 }
   PutByte(length(Don) And 127);  { CL0 }
  End;
 For i := 1 To length(Don) Do
  If CL_Exist Or (Don[i]>#3) Then PutByte(Byte(Don[i]));
 PutByte(ETX);
End;



Function  ComMin.Init( UART : Word; IRQ : Byte;
                       Spd : LongInt;
                       Par : Byte;
                       BufIn : Word;
                       BufOut : Word ) : Boolean;
Begin
 If (UART<>0) Then
  Begin
   Init := ComXD.Init(UART,IRQ,115200 Div Spd,Par,BufIn,BufOut);
  End
 Else Init := FALSE;
End;


Procedure  ComMin.Done;
Begin
 ComXD.Done;
End;

Procedure ComMin.Send( Var p; lg : Word );
Var i : Word;
    a : Array[0..10000] Of Byte Absolute p;
Begin
 i := 0;
 While i<lg Do
  Begin
   Inc(i,Transmit(a[i],lg-i));
  End;
End;




End.
