{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

Unit XSerDigi;

Interface

Uses XSer;

Type ComXD = Object(ComX)

         Private

         Digi    : Boolean;
         Channel : Word;

         (*
           comment multiplier par 10 la vitesse ???
           ajouter un (mini) cache en lecture!!!!
         *)

         CBuf_data   : Array[0..15] Of Char;
         CBuf_nb     : Word;
         CBuf_iread  : Word;
         CBuf_iwrite : Word;

         Public

         Function  Init( UART : Word;
                         IRQ : Byte;
                         Spd : Word;
                         Par : Byte;
                         BufIn : Word;
                         BufOut : Word ) : Boolean;
         Procedure Done;

         Procedure SetBaud( Baud : Word );              { pas en digi }
         Procedure SetParam( Parameters : Byte );       { pas en digi }
         Procedure SetBreak( BrkOn : Boolean );         { different en digi }
         Procedure SetLoop( LoopOn : Boolean );         { pas en digi }

         Procedure SetModemCtrl( Parameters : Byte );   { pas en digi }
         Function  GetModemCtrl : Byte;                 { pas en digi }

         Function  LineError : Boolean;                 { pas en digi }
         Function  GetLineState : Byte;                 { pas en digi }

         Function  NewModemState : Boolean;             { pas en digi }
         Function  GetModemState : Byte;                { pas en digi }

         Function  ReceiveCount : Word;
         Function  ReceiveAvail : Word;
         Function  ReceiveChar( Var C : Char ) : Boolean;
         Function  Receive( Var p; LgMax : Word ) : Word;
         Procedure ReceiveClear;

         Function  TransmitCount : Word;
         Function  TransmitAvail : Word;
         Function  TransmitChar( C : Char ) : Boolean;
         Function  Transmit( Var p; Lg : Word ) : Word;
         Procedure TransmitClear;

         Function  GetChannel : Word;                    { pas en XSer }

         Function CCount : Word;

       End;


Implementation

Const INTCOM = $14;

Function i14_init( channel, baud, parity, data, stop : Word ) : Boolean; Assembler;
Asm
 mov dx, [channel]
 mov ax, 0400h	      { no break }
 mov bh, BYTE [parity]
 mov bl, BYTE [stop]
 mov ch, BYTE [data]
 mov cl, BYTE [baud]
 int INTCOM
 cmp ah, 0FFh
 je  @@err
 mov ax, TRUE
 jmp @@fin
@@err:
 xor ax, ax
@@fin:
End;


Function i14_incount( channel : Word ) : Word; Assembler;
Asm
 mov dx, [channel]
 mov ax, 0FD02h
 int INTCOM
 mov ax, cx
End;

Function i14_clear( channel : Word ) : Boolean; Assembler;
Asm
 mov dx, [channel]
 mov ah, 009h
 int INTCOM
 cmp ah, 0FFh
 je @@err
 mov ax, TRUE
 jmp @@fin
@@err:
 xor ax, ax
@@fin:
End;

Function i14_inclear( channel : Word ) : Boolean; Assembler;
Asm
 mov dx, [channel]
 mov ah, 010h
 int INTCOM
 cmp ah, 0FFh
 je @@err
 mov ax, TRUE
 jmp @@fin
@@err:
 xor ax, ax
@@fin:
End;

Function i14_outclear( channel : Word ) : Boolean; Assembler;
Asm
 mov dx, [channel]
 mov ah, 011h
 int INTCOM
 cmp ah, 0FFh
 je @@err
 mov ax, TRUE
 jmp @@fin
@@err:
 xor ax, ax
@@fin:
End;

Function i14_putc( channel : Word; c : Word ) : Boolean; Assembler;
Asm
 mov dx, [channel]
 mov ah, 001h
 mov al, BYTE [c]
 int INTCOM
 test ah, 128
 jnz @@err
 mov ax, TRUE
 jmp @@fin
@@err:
 xor ax, ax
@@fin:
End;

Function i14_getc( channel : Word ) : Integer; Assembler;
Asm
 mov dx, [channel]
 mov ah,0FCh
 int INTCOM
 test ah, 128
 jnz @@err
 xor ah, ah
 jmp @@fin
@@err:
 mov ax, -1
@@fin:
End;

Function i14_clearflow( channel : Word ) : Boolean; Assembler;
Asm
 mov dx, [channel]
 mov ah, 01Eh
 mov bh, 0
 mov bl, 0
 mov cx, 0
 int INTCOM
 cmp ah, 0FFh
 je @@err
 mov ax, TRUE
 jmp @@fin
@@err:
 xor ax, ax
@@fin:
End;

Procedure i14_setdtrrts( channel : Word; dtrrts : Word ); Assembler;
Asm
 mov dx, [channel]
 mov ax, 00501h
 mov bl, BYTE [dtrrts]
 and bl, 1+2
 int INTCOM
End;

Function i14_write( channel : Word; var p; len : Word ) : Word; Assembler;
Asm
 mov cx, [len]
 jcxz @@fin
 mov dx, [channel]
 mov ah, 00Eh
 les bx, [p]
 int INTCOM
 jmp @@quit
@@fin:
 xor ax, ax
@@quit:
End;

Function i14_outavail( channel : Word ) : Word; Assembler;
Asm
 mov dx, [channel]
 mov ah, 012h
 int INTCOM
End;

Function i14_outcount( channel : Word ) : Word; Assembler;
Asm
 mov dx, [channel]
 mov ax, 0FD01h
 int INTCOM
 mov ax, cx
End;

Function i14_read( channel : Word; Var dest; len : Word ) : Word; Assembler;
Asm
 mov cx, [len]
 jcxz @@ok
 mov dx, [channel]
 mov ah, 00Fh
 les bx, [dest]
 int INTCOM
 jmp @@fin
@@ok:
 xor ax, ax
@@fin:
End;

Function i14_timeout( channel : Word; enable : Word ) : Boolean; Assembler;
Asm
 mov dx, [channel]
 mov ah, 020h
 mov al, BYTE [enable]
 and al, 1
 int INTCOM
 cmp ah, 0FFh
 je @@err
@@ok:
 mov ax, TRUE
 jmp @@fin
@@err:
 xor ax, ax
@@fin:
End;

Procedure i14_SendBreak( channel : Word ); Assembler;
Asm
 mov dx, [channel]
 mov ax, 0700h
 int INTCOM
End;

Const SpdDigi : Array[0..17] Of Word = (
        BAUD110, BAUD150, BAUD300, BAUD600, BAUD1200,
        BAUD2400, BAUD4800, BAUD9600, BAUD19200, BAUD38400,
        115200 DIV 57600, 0, 115200 DIV 115200, 1, BAUD75, 1, 1, 1
       );

Function  ComXD.Init( UART : Word;
                      IRQ : Byte;
                      Spd : Word;
                      Par : Byte;
                      BufIn : Word;
                      BufOut : Word ) : Boolean;
Var s : Byte;
    parity : Byte;
    data   : Byte;
    stop   : Byte;
    i : Word;
Begin
 If IRQ=$FF Then
  Begin
   CBuf_iread := 0;
   CBuf_iwrite := 0;
   CBuf_nb := 0;

   Digi := TRUE;
   Channel := UART;
   s := 0;
   For i := 0 To 17 Do
    If SpdDigi[i]=Spd Then
     Begin
      s := i;
      break;
     End;
   data := Par And 3;
   stop := (Par And 4) Shr 2;
   parity := (Par And (8+16)) Shr 3;
   if parity=3 then parity:=2;

   if i14_init(channel,s,parity,data,stop) Then
    Begin
     i14_clear(channel);
     i14_clearflow(channel);
     i14_setdtrrts(channel,1+2);
     i14_timeout(channel,0);

     Init := TRUE;
    End
   Else Init := FALSE;
  End
 Else
  Begin
   Digi := FALSE;
   Init := ComX.Init(UART,IRQ,Spd,Par,BufIn,BufOut);
  End;
End;

Procedure ComXD.Done;
Begin
 If Not(Digi) Then ComX.Done;
End;


Procedure ComXD.SetBaud( Baud : Word );
Begin
 If Not(Digi) Then ComX.SetBaud(Baud);
End;

Procedure ComXD.SetParam( Parameters : Byte );
Begin
 If Not(Digi) Then ComX.SetParam(Parameters);
End;

Procedure ComXD.SetBreak( BrkOn : Boolean );
Begin
 If Not(Digi) Then ComX.SetBreak(BrkOn)
 Else If BrkOn Then i14_SendBreak(channel);
End;

Procedure ComXD.SetLoop( LoopOn : Boolean );
Begin
 If Not(Digi) Then ComX.SetLoop(LoopOn);
End;

Procedure ComXD.SetModemCtrl( Parameters : Byte );
Begin
 If Not(Digi) Then ComX.SetModemCtrl(Parameters);
End;

Function  ComXD.GetModemCtrl : Byte;
Begin
 If Not(Digi) Then GetModemCtrl := ComX.GetModemCtrl
 Else GetModemCtrl := CT_DTR+CT_RTS;
End;

Function  ComXD.LineError : Boolean;
Begin
 If Not(Digi) Then LineError := ComX.LineError
 Else LineError := FALSE;
End;

Function  ComXD.GetLineState : Byte;
Begin
 If Not(Digi) Then GetLineState := ComX.GetLineState
 Else GetLineState := LN_THRE+LN_TSRE;
End;

Function  ComXD.NewModemState : Boolean;
Begin
 If Not(Digi) Then NewModemState := ComX.NewModemState
 Else NewModemState := FALSE;
End;

Function  ComXD.GetModemState : Byte;
Begin
 If Not(Digi) Then GetModemState := ComX.GetModemState
 Else GetModemState := MD_RTS+MD_DSR;
End;

Function  ComXD.ReceiveCount : Word;
Begin
 If Not(Digi) Then ReceiveCount := ComX.ReceiveCount
 Else ReceiveCount := i14_incount(channel)+CBuf_nb;
End;

Function  ComXD.CCount : Word;
Var z : Integer;
Begin
 If Not(Digi) Then CCount := ComX.ReceiveCount
 Else
  Begin
   While (CBuf_nb<SizeOf(CBuf_data)) Do
    Begin
     z := i14_getc(channel);
     If (z=-1) Then Break;
     CBuf_data[CBuf_iwrite] := Char(z);
     Inc(CBuf_nb);
     Inc(CBuf_iwrite);
     If (CBuf_iwrite>=SizeOf(CBuf_data)) Then CBuf_iwrite := 0;
    End;

   CCount := CBuf_nb;
  End;
End;

Function  ComXD.ReceiveAvail : Word;
Begin
 If Not(Digi) Then ReceiveAvail := ComX.ReceiveAvail
 Else ReceiveAvail := 30000-(i14_incount(channel)+CBuf_nb);
End;

Function  ComXD.ReceiveChar( Var C : Char ) : Boolean;
Var z : Integer;
Begin
 If Not(Digi) Then ReceiveChar := ComX.ReceiveChar(C)
 Else
  Begin
   While (CBuf_nb<SizeOf(CBuf_data)) Do
    Begin
     z := i14_getc(channel);
     If (z=-1) Then Break;
     CBuf_data[CBuf_iwrite] := Char(z);
     Inc(CBuf_nb);
     Inc(CBuf_iwrite);
     If (CBuf_iwrite>=SizeOf(CBuf_data)) Then CBuf_iwrite := 0;
    End;

   If (CBuf_nb>0) Then
    Begin
     C := CBuf_data[CBuf_iread];
     Inc(CBuf_iread);
     If (CBuf_iread>=SizeOf(CBuf_data)) Then CBuf_iread := 0;
     Dec(CBuf_nb);
     ReceiveChar := TRUE;
    End
   Else
    Begin
     ReceiveChar := FALSE;
    End;
  End;
End;

Function  ComXD.Receive( Var p; LgMax : Word ) : Word;
Var i : Word;
    c : Array[0..1000] Of Char Absolute p;
Begin
 If Not(Digi) Then Receive := ComX.Receive(p,LgMax)
 Else
  Begin
   i:=0;
   While (i<LgMax) And ReceiveChar(c[i]) Do Inc(i);

   Receive := i;
  End;
End;

Procedure ComXD.ReceiveClear;
Begin
 If Not(Digi) Then ComX.ReceiveClear
 Else
  Begin
   CBuf_iread := 0;
   CBuf_iwrite := 0;
   CBuf_nb := 0;

   i14_inclear(channel);
  End;
End;

Function  ComXD.TransmitCount : Word;
Begin
 If Not(Digi) Then TransmitCount := ComX.TransmitCount
 Else TransmitCount := i14_outcount(channel);
End;

Function  ComXD.TransmitAvail : Word;
Begin
 If Not(Digi) Then TransmitAvail := ComX.TransmitAvail
 Else TransmitAvail := i14_outavail(channel);
End;


Function  ComXD.TransmitChar( C : Char ) : Boolean;
Begin
 If Not(Digi) Then TransmitChar := ComX.TransmitChar(C)
 Else TransmitChar := i14_putc(channel,Integer(c));
End;

Function  ComXD.Transmit( Var p; Lg : Word ) : Word;
Begin
 If Not(Digi) Then Transmit := ComX.Transmit(p,Lg)
 Else Transmit := i14_write(channel,p,lg);
End;

Procedure ComXD.TransmitClear;
Begin
 If Not(Digi) Then ComX.TransmitClear
 Else i14_outclear(channel);
End;

Function  ComXD.GetChannel : Word;
Begin
 If Not(Digi) Then GetChannel := $FFFF
 Else GetChannel := channel;
End;


End.
